<%@ page
	pageEncoding="UTF-8"
	session="false"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.clients.web.Base"	
	import="net.sf.basedb.clients.web.util.HTML"	
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(request, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final String home = ExtensionsControl.getHomeUrl("net.sf.basedb.reggie");
DbControl dc = null;
try
{
	dc = sc.newDbControl();
	final User user = User.getById(dc, sc.getLoggedInUserId());
%>
<base:page type="default" >
<base:head 
	scripts="~../reggie-2.js,~flowcell_registration.js" 
	styles="path.css,~../css/reggie-2.css"
/>
<base:body>

	<p:path><p:pathelement 
		title="Reggie" href="<%="../index.jsp?ID="+ID%>" 
		/><p:pathelement title="Register clustering" 
		/></p:path>

	<div class="content">
	<form name="reggie" id="wizard" class="wizard">

	<div class="step" id="step-1">
		<div class="step-no">1</div>
		<div class="step-title">Select flow cells</div>
		<div class="step-content">

			<table class="step-form">
			<tr class="align-top">
				<td class="prompt">Flow cells</td>
				<td class="input">
					<select class="required" name="flowcells" id="flowcells" 
						multiple size="4"></select>
				</td>
				<td class="status" id="flowcells.status"></td>
				<td class="help">
					<span id="flowcells.message" class="message"></span>
					Select 1 or 2 existing flow cells. The list contain all flow cells that
					has not yet been clustered or sequenced (determined by the absence of a 'creation' date).
				</td>
			</tr>
			<tr>
				<td></td>
				<td>
					<div class="messagecontainer note" style="margin-left: 0; margin-right: 0; width: 95%; box-sizing: border-box;">
						<b>Note!</b>
						Register each flow cell separately if the outcome, cluster date, operator, etc. is different.
					</div>
				</td>
				<td class="status"></td>
				<td class="help">
				</td>
			</tr>
			<tr>
				<td class="prompt">Outcome</td>
				<td class="input">
					<label><input type="radio" name="outcome" id="outcomeSuccess" 
						checked>Success</label> - continue with sequencing<br>
					<label><input type="radio" name="outcome" id="outcomeFailed" 
						>Failure</label> - no sequencing
				</td>
				<td class="status"></td>
				<td class="help">
					Select the <b>Success</b> option if the flow cell is ready for sequencing. 
					Select the <b>Failure</b> option if it was not poosible to start sequencing
					the flow cells.
				</td>
			</tr>
			</table>
		</div>
	</div>
	
	<div class="step" id="step-2">
		<div class="step-no">2</div>
		<div class="step-title">Clustering information</div>
		<div class="step-content">

			<table class="step-form">
			<tr>
				<td class="prompt">Start date</td>
				<td class="input">
					<input type="text" name="clusterDate" id="clusterDate"
						class="auto-init required" data-auto-init="focus-on-enter" data-next-focus="clusterOperator"
						style="width: 12em;" maxlength="10">
				
						<base:icon 
							id="clusterDateCalendar"
							subclass="auto-init"
							data-auto-init="calendar"
							data-textarea-id="clusterDate"
							data-date-format="yyyyMMdd"
							image="calendar.png" 
							tooltip="Select a date from a calendar" 
							tabindex="-1"
						/>
				</td>
				<td class="status" id="clusterDate.status"></td>
				<td class="help">
					<span id="clusterDate.message" class="message"></span>
					Date the clustering was started (YYYYMMDD or MMDD)
				</td>
			</tr>
			<tr>
				<td class="prompt">Operator</td>
				<td class="input">
					<input type="text" name="clusterOperator" id="clusterOperator" 
						class="auto-init" data-auto-init="focus-on-enter" data-next-focus="cBot"
						value="<%=HTML.encodeTags(user.getName()) %>" 
						maxlength="255">
				</td>
				<td class="status" id="clusterOperator.status"></td>
				<td class="help">
					<span id="clusterOperator.message" class="message"></span>
				</td>
			</tr>
			<tr>
				<td class="prompt">Cluster generator</td>
				<td class="input">
					<select name="cBot" id="cBot"
						class="auto-init" data-auto-init="focus-on-enter" data-next-focus="clusterProtocol"
					></select>
				</td>
				<td class="status" id="cBot.status"></td>
				<td class="help">
					<span id="cBot.message" class="message"></span>
					Select the machine which was used to generate clusters.
				</td>
			</tr>
			<tr>
				<td class="prompt">Protocol</td>
				<td class="input">
					<select name="clusterProtocol" id="clusterProtocol"
						class="auto-init" data-auto-init="focus-on-enter" data-next-focus="fc-0.externalId"
					></select>
				</td>
				<td class="status" id="clusterProtocol.status"></td>
				<td class="help">
					<span id="clusterProtocol.message" class="message"></span>
					Select the protocol which was used in the clustering.
				</td>
			</tr>

			<tbody id="fc-0-section">
			<tr class="section-header">
				<td id="fc-0.name.c" colspan="4">Flow cell A</td>
			</tr>
			<tr valign="top">
				<td class="subprompt">ID</td>
				<td class="input">
					<input type="text" name="fc-0.externalId" id="fc-0.externalId"
						class="required auto-init" data-auto-init="focus-on-enter" data-next-focus="fc-0.comments"
						style="width: 12em;">
				</td>
				<td class="status" id="fc-0.externalId.status"></td>
				<td class="help">
					<span id="fc-0.externalId.message" class="message"></span>
					The barcode of the flow cell.
				</td>
			</tr>
			<tr class="align-top">
				<td class="subprompt">Comments</td>
				<td class="input">
					<textarea name="fc-0.comments" id="fc-0.comments" rows="4"></textarea>
				</td>
				<td class="status" id="fc-0.comments.status"></td>
				<td class="help">
					<span id="fc-0.comments.message" class="message"></span>
					Comments about the clustering.
				</td>
			</tr>
			</tbody>
			
			<tbody id="fc-1-section">
			<tr class="section-header">
				<td id="fc-1.name.c" colspan="4">Flow cell B</td>
			</tr>
			<tr>
				<td class="subprompt">ID</td>
				<td class="input">
					<input type="text" 
						name="fc-1.externalId" id="fc-1.externalId"
						class="required auto-init" data-auto-init="focus-on-enter" data-next-focus="fc-1.comments"
						style="width: 12em;"
						>
				</td>
				<td class="status" id="fc-1.externalId.status"></td>
				<td class="help">
					<span id="fc-1.externalId.message" class="message"></span>
					The barcode of the flow cell.
				</td>
			</tr>
			<tr class="align-top">
				<td class="subprompt">Comments</td>
				<td class="input">
					<textarea name="fc-1.comments" id="fc-1.comments" rows="4"></textarea>
				</td>
				<td class="status" id="fc-1.comments.status"></td>
				<td class="help">
					<span id="fc-1.comments.message" class="message"></span>
					Comments about the clustering.
				</td>
			</tr>
			</tbody>
			</table>
		</div>
	</div>
	
	<div id="wizard-status"></div>
	
	<table class="navigation" id="navigation">
	<tr>
		<td><base:button id="gocancel" title="Cancel" /></td>
		<td><base:button id="gonext" title="Next" image="<%=home+"/images/gonext.png"%>" /></td>
		<td><base:button id="goregister" title="Register" image="<%=home+"/images/import.png"%>"  /></td>
		<td><base:button id="gorestart" title="Restart" image="<%=home+"/images/goback.png"%>" /></td>
		<td id="gonext-message" class="message"></td>
	</tr>
	</table>
	
	</form>
	</div>
	
</base:body>
</base:page>
<%
}
finally
{
	if (dc != null) dc.close();
}
%>