var Report = function()
{
	var report = {};
	var debug = 0;
	
	var periodIsValid = true;
	
	report.initPage = function()
	{
		var frm = document.forms['reggie'];

		// Step 1

		// Step 2
		Events.addEventHandler('step-2', 'wizard-initialize', report.initializeStep2);
		Events.addEventHandler('step-2', 'wizard-validate', report.validateStep2);
		Events.addEventHandler('fromdate', 'blur', report.dateOnChange)
		Events.addEventHandler('todate', 'blur', report.dateOnChange)
		Events.addEventHandler('sampletype', 'change', report.sampleTypeOnChange);
		Events.addEventHandler('tablealternatives', 'change', report.tableAlternativesOnChange);
		
		// Final registration
		Events.addEventHandler('wizard', 'wizard-submit', report.submit);
		Events.addEventHandler('printButton', 'click', report.printVersion);

		// Navigation
		Buttons.addClickHandler('gocancel', Wizard.restartWizard);
		Buttons.addClickHandler('gorestart', Wizard.restartWizard);
		Buttons.addClickHandler('gonext', Wizard.goNextOnClick);
		Buttons.addClickHandler('gocreate', Wizard.goRegister);

		Doc.show('step-1');
		Doc.show('gonext');
	}
	
	report.initializeStep2 = function()
	{
		var frm = document.forms['reggie'];
		Wizard.setCurrentStep(2);
		Doc.show('gocancel');
		Doc.show('gocreate');
		var reportType = frm.reporttype.value;
		
		// Hide all parameter fiels
		Doc.hide('report-period');
		Doc.hide('view-type');
		Doc.hide('sample-type');
		Doc.hide('table-alternatives');
		Doc.hide('blood-filter');

		// Re-enable base on report type
		if (reportType == 'samplecount')
		{
			Doc.show('report-period');
			Doc.show('view-type');
			Doc.show('sample-type');
			Doc.show('table-alternatives');
			Doc.show('blood-filter');
			frm.tablealternatives.disabled = true;
			frm.bloodsamplefilter.disabled = true;
		}
		else if (reportType == 'consentcount')
		{
			Doc.show('report-period');
		}
		else if (reportType == 'patientcount')
		{
			Doc.show('report-period');
			Doc.show('view-type');
		}
		else if (reportType == 'overviewreport')
		{
			Doc.show('report-period');
			Doc.show('blood-filter');
		}
		else if (reportType == 'missingsampledatareport')
		{
			Doc.show('sample-type');
			Doc.show('blood-filter');
			frm.bloodsamplefilter.disabled = true;
		}

		frm.fromdate.focus();
	}
	
	report.validateStep2 = function(event)
	{
		if (!periodIsValid) event.preventDefault();
	}

	report.dateOnChange = function()
	{
		var frm = document.forms['reggie'];		
		var fromDate = frm.fromdate.value;
		var toDate = frm.todate.value;
		
		periodIsValid = false;
		Wizard.setInputStatus('period');

		if (fromDate != '')
		{
			fromDate = Reggie.autoFillDate(fromDate, true);
			frm.fromdate.value = fromDate;			
			if (!Dates.isDate(fromDate, 'yyyyMMdd'))
			{
				Wizard.setInputStatus('period', 'invalid', 'Not a valid from-date');
				return;
			}
		}

		if (toDate != '')
		{
			toDate = Reggie.autoFillDate(toDate, true);
			frm.todate.value = toDate;			
			if (!Dates.isDate(toDate, 'yyyyMMdd'))
			{
				Wizard.setInputStatus('period', 'invalid', 'Not a valid to-date');
				return;
			}
		}
		
		if (toDate && fromDate)
		{
			if (fromDate > toDate)
			{
				Wizard.setInputStatus('period', 'invalid', 'Invalid period')
				return;
			}			
		}
		
		Wizard.setInputStatus('period', 'valid');
		periodIsValid = true;
	}

	report.sampleTypeOnChange = function()
	{
		var frm = document.forms['reggie'];
		var reportType = frm.reporttype.value;
		var sampleType = frm.sampletype.value;
		var tableAlternatives = frm.tablealternatives.value;
		
		if (sampleType == 'blood')
		{
			if (reportType == 'samplecount')
			{
				// Enable table alternatives menu
				frm.tablealternatives.disabled = false;
				// In principal this case should not exist when sample type has just been changed to 'blood'
				if (tableAlternatives == 'blood_sample_table_with_filter')
				{
					// Enable blood sample type filter menu
					frm.bloodsamplefilter.disabled = false;
				}
			}
			else
			{
				// Enable blood sample type filter menu
				frm.bloodsamplefilter.disabled = false;
			}
		}
		else
		{
			// Disable table alternatives menu and reset option
			frm.tablealternatives.selectedIndex = 0;
			frm.tablealternatives.disabled = true;
			// Disable blood sample type filter menu and reset option
			frm.bloodsamplefilter.selectedIndex = 0;
			frm.bloodsamplefilter.disabled = true;
		}
	}

	report.tableAlternativesOnChange = function()
	{
		var frm = document.forms['reggie'];
		var sampleType = frm.sampletype.value;
		var tableAlternatives = frm.tablealternatives.value;
		if (sampleType == 'blood' && tableAlternatives == 'blood_sample_table_with_filter')
		{
			// Enable blood sample type filter menu
			frm.bloodsamplefilter.disabled = false;
		}
		else
		{
			// Disable blood sample type filter menu and reset option
			frm.bloodsamplefilter.selectedIndex = 0;
			frm.bloodsamplefilter.disabled = true;
		}
	}
	
	report.submit = function()
	{
		var frm = document.forms['reggie'];		

		var url = '../SampleReport.servlet?ID='+App.getSessionId();
		url += '&cmd='+frm.reporttype.value;
		url += '&fdate='+frm.fromdate.value;
		url += '&tdate='+frm.todate.value;
		url += '&vtype='+frm.viewtype.value;
		url += '&stype='+frm.sampletype.value;
		url += '&tablealternatives='+frm.tablealternatives.value;
		url += '&bloodsamplefilter='+frm.bloodsamplefilter.value;

		Wizard.showLoadingAnimation('Generating report...');
		Wizard.asyncJsonRequest(url, report.onReportGenerated);
	}
	
	report.onReportGenerated = function(response)
	{
		var reportData = response.report;
		var permissionDeniedForPatientName = reportData.permissionDeniedForPatientName;
		var permissionDeniedForPad = reportData.permissionDeniedForPad;
	
		var reportTable;
		var frm = document.forms['reggie'];		
		var reportType = frm.reporttype.value;
		var sampleType = frm.sampletype.value;
		var tableAlternatives = frm.tablealternatives.value;
	
		if (reportData != null)
		{
			if ('samplecount' == reportType)
			{
				reportTable = createItemCountReport(reportData, reportType);
			}
			else if ('consentcount' == reportType)
			{
				reportTable = createConsentCountReport(reportData);
			}
			else if ('patientcount' == reportType)
			{
				reportTable = createItemCountReport(reportData, reportType);
			}
			else if ('overviewreport' == reportType)
			{
				reportTable = createOverviewReport(reportData);
			}
			else if ('missingsampledatareport' == reportType)
			{
				reportTable = createMissingSampleDataReport(reportData);
			}
		}
		else
		{
			Wizard.setFatalError('No values could be found during given period');
			return;
		}

		var reportDiv = Doc.element('reportdiv');
		reportDiv.appendChild(reportTable);
		
		// Optional extra tables
		if ('samplecount' == reportType)
		{
			if ('blood' == sampleType && tableAlternatives == 'full_blood_sample_tables' && reportData != null)
			{
				var spacer0 = document.createElement('text');
				spacer0.innerHTML = "<BR>";
				reportDiv.appendChild(spacer0);
				var spacer = document.createElement('text');
				spacer.innerHTML = "<BR>";
				reportDiv.appendChild(spacer);
				// Follow-up
				reportDiv.appendChild(spacer);
				var reportFollowUp = reportData.reportFollowUp;
				var reportFollowUpTable = createItemCountReport(reportFollowUp, reportType);
				reportDiv.appendChild(reportFollowUpTable);
				// Not follow-up
				reportDiv.appendChild(spacer);
				reportDiv.appendChild(spacer);
				var reportNotFollowUp = reportData.reportNotFollowUp;
				var reportNotFollowUpTable = createItemCountReport(reportNotFollowUp, reportType);
				reportDiv.appendChild(reportNotFollowUpTable);
				// Unknown
				reportDiv.appendChild(spacer);
				reportDiv.appendChild(spacer);
				var reportUnknown = reportData.reportUnknown;
				var reportUnknownTable = createItemCountReport(reportUnknown, reportType);
				reportDiv.appendChild(reportUnknownTable);
				// PreNeo
				reportDiv.appendChild(spacer);
				reportDiv.appendChild(spacer);
				var reportPreNeo = reportData.reportPreNeo;
				var reportPreNeoTable = createItemCountReport(reportPreNeo, reportType);
				reportDiv.appendChild(reportPreNeoTable);
				// PreOp
				reportDiv.appendChild(spacer);
				reportDiv.appendChild(spacer);
				var reportPreOp = reportData.reportPreOp;
				var reportPreOpTable = createItemCountReport(reportPreOp, reportType);
				reportDiv.appendChild(reportPreOpTable);
				// FollowUp06
				reportDiv.appendChild(spacer);
				reportDiv.appendChild(spacer);
				var reportFollowUp06 = reportData.reportFollowUp06;
				var reportFollowUp06Table = createItemCountReport(reportFollowUp06, reportType);
				reportDiv.appendChild(reportFollowUp06Table);
				// FollowUp12
				reportDiv.appendChild(spacer);
				reportDiv.appendChild(spacer);
				var reportFollowUp12 = reportData.reportFollowUp12;
				var reportFollowUp12Table = createItemCountReport(reportFollowUp12, reportType);
				reportDiv.appendChild(reportFollowUp12Table);
				// FollowUp36
				reportDiv.appendChild(spacer);
				reportDiv.appendChild(spacer);
				var reportFollowUp36 = reportData.reportFollowUp36;
				var reportFollowUp36Table = createItemCountReport(reportFollowUp36, reportType);
				reportDiv.appendChild(reportFollowUp36Table);
				//
				// Reset # of blood samples with unknown site or creation date to that for unfiltered report
				unknownCreation = reportData.statistics.noDate;
				unknownSite = reportData.statistics.unknownSite;
			}
		}
		else if ('consentcount' == reportType)
		{
			var spacer0 = document.createElement('text');
			spacer0.innerHTML = "<BR>";
			reportDiv.appendChild(spacer0);
			var spacer = document.createElement('text');
			spacer.innerHTML = "<BR>";
			reportDiv.appendChild(spacer);
			// Table with consents in different categories with date, as well as consents with unknown date
			reportDiv.appendChild(spacer);
			var hasDateTable = createConsentCountHasDateTable(reportData);
			reportDiv.appendChild(hasDateTable);
			// Table with consents in different categories with unknown date, as well as missing consents
			reportDiv.appendChild(spacer);
			var unknownDateTable = createConsentCountUnknownDateTable(reportData);
			reportDiv.appendChild(unknownDateTable);
		}
		else if ('overviewreport' == reportType)
		{
			var spacer0 = document.createElement('text');
			spacer0.innerHTML = "<BR>";
			reportDiv.appendChild(spacer0);
			var spacer = document.createElement('text');
			spacer.innerHTML = "<BR>";
			reportDiv.appendChild(spacer);
			// Table with patients having at least one item of different sample types
			reportDiv.appendChild(spacer);
			var patientWithSampleTable = createOverviewPatientWithSampleTable(reportData);
			reportDiv.appendChild(patientWithSampleTable);
			// Table with patients having different combinations of sample types
			reportDiv.appendChild(spacer);
			var patientDetailedTable = createOverviewPatientDetailedTable(reportData);
			reportDiv.appendChild(patientDetailedTable);
		}
		// Summary list
		var summaryList = document.createElement('ul');
		if (unknownSite == null) unknownSite = 0;
		if (unknownCreation == null) unknownCreation = 0;
		if ('samplecount' == reportType)
		{
			var samples = 'specimens';
			if ('nospecimen' == sampleType)
			{
				samples = '"no specimens"';
			}
			else if ('blood' == sampleType)
			{
				samples = 'blood samples';
			}
			summaryList.appendChild(getListElement(unknownSite + ' ' + samples + ' registered to unknown sites.'));
			summaryList.appendChild(getListElement(unknownCreation + ' ' + samples + ' without creation date. These are included in the \'Total\' column.'));
		}
		else if ('consentcount' == reportType)
		{
			var numDuplicates = 0;
			if (report != null)
			{
				var statistics = reportData.statistics;
				numDuplicates = statistics.duplicateKey;
			}
			if (numDuplicates == null)
			{
				numDuplicates = 0;
			}
			summaryList.appendChild(getListElement(unknownSite + ' consents registered to unknown sites.'));
			summaryList.appendChild(getListElement(unknownCreation + ' consents without known date. These are included in the \'Total\' column.'));
			summaryList.appendChild(getListElement(numMissing + ' missing consents for cases and blood samples. These are NOT included in the \'Total\' column.'));
			summaryList.appendChild(getListElement(numDuplicates + ' duplicates ignored.'));

			var patientsWithMultipleDates = statistics.patientsWithMultipleDatesKey;
			var counter = 0;
			for (var key in patientsWithMultipleDates)
			{
				counter++;
			}
			var patientsWithMultipleDatesText = counter + ' patients with multiple dates.';
			summaryList.appendChild(getListElement(patientsWithMultipleDatesText));
		}
		else if ('patientcount' == reportType)
		{
			summaryList.appendChild(getListElement(unknownSite + ' patients registered to unknown sites.'));
			summaryList.appendChild(getListElement(unknownCreation + ' patients without creation date. These are included in the \'Total\' column.'));
		}
		else if ('overviewreport' == reportType)
		{
			var numBloodNoDate = 0;
			var numBloodFUNoDate = 0;
			var numSpecimenNoDate = 0;
			var numNoSpecimenNoDate = 0;
			if (report != null)
			{
				var statistics = reportData.statistics;
				numBloodNoDate = statistics.bloodSampleNoDate;
				numBloodFUNoDate = statistics.bloodSampleFollowUpNoDate;
				numSpecimenNoDate = statistics.specimenNoDate;
				numNoSpecimenNoDate = statistics.noSpecimenNoDate;
			}
			if (numBloodNoDate == null)
			{
				numBloodNoDate = 0;
			}
			if (numBloodFUNoDate == null)
			{
				numBloodFUNoDate = 0;
			}
			if (numSpecimenNoDate == null)
			{
				numSpecimenNoDate = 0;
			}
			if (numNoSpecimenNoDate == null)
			{
				numNoSpecimenNoDate = 0;
			}
			summaryList.appendChild(getListElement(unknownSite + ' patients registered to unknown sites.'));
			summaryList.appendChild(getListElement(numPatientsNoSamples + ' patients with no samples.'));
			summaryList.appendChild(getListElement('Note: Consents of type "Yes" include consents without patient id (PAT#) or date.'));
			summaryList.appendChild(getListElement('Note: Data in column "Blood samples follow-up" are not affected by blood sample filter.'));
			summaryList.appendChild(getListElement('Note: Time period filter only affects sample items, patients and consents are derived from these.'));
			summaryList.appendChild(getListElement('Note: If creation date is unknown, registration date is used instead.'));
			summaryList.appendChild(getListElement('Items with unknown creation date: Blood ' + numBloodNoDate + ', Blood follow-up ' + numBloodFUNoDate + ', Specimen ' + numSpecimenNoDate + ', No specimen ' + numNoSpecimenNoDate));
		}
		else if ('missingsampledatareport' == reportType)
		{
			summaryList.appendChild(getListElement('Note: Patient name is considered missing if either "all first names" or "family name" is missing.'));
			if (permissionDeniedForPatientName)
			{
				var patientNamePermissionWarning = document.createElement('li');
				patientNamePermissionWarning.innerHTML = 'Sorry, logged-in user does not have permission to check patient names.';
				summaryList.appendChild(patientNamePermissionWarning);
			}
			if (permissionDeniedForPad)
			{
				var padPermissionWarning = document.createElement('li');
				padPermissionWarning.innerHTML = 'Sorry, logged-in user does not have permission to check PAD values.';
				summaryList.appendChild(padPermissionWarning);
			}
		}
		reportDiv.appendChild(summaryList);
		if ('consentcount' == reportType)
		{
			// Add table with patients with consents with multiple dates
			var multipleDatesTable = createConsentTablePatientsWithMultipleDates(reportData);
			reportDiv.appendChild(multipleDatesTable);
		}
		
		Doc.show('step-3');
		Doc.show('gorestart');
	}

	
	report.printVersion = function()
	{
		var frm = document.forms['reggie'];
		var reportName = frm.reporttype[frm.reporttype.selectedIndex].text;
		var printNote = '<b>Note!</b> For better printing set page orientation to <i>landscape</i>.';
		Reggie.openPrintWindow('step-3-content', reportName, 'landscape', printNote, '../', 'report.css');
	}

	return report;
}();

Doc.onLoad(Report.initPage);


var numCols;
var unknownSite = 0;
var unknownCreation = 0;
var numMissing = 0;
var numPatientsNoSamples = 0;

var month=new Array(12);
	month[0]="Jan";
	month[1]="Feb";
	month[2]="Mar";
	month[3]="Apr";
	month[4]="May";
	month[5]="Jun";
	month[6]="Jul";
	month[7]="Aug";
	month[8]="Sep";
	month[9]="Oct";
	month[10]="Nov";
	month[11]="Dec";



function createMissingConsentDataSampleListPreview(allLines, previewTitle, previewList)
{
	var numCases = allLines.length - 2; // First line is a header line
		
	var html = '<tr><th>'+allLines[0].replace(/\t/g, '</th><th>')+'</th></tr>';
	// Check last column for the 'Consent' value
	var numConsentWithoutDate = 0;
	var numMissingConsent = 0;
	var numYesConsent = 0;
	var numNoConsent = 0;
	var numNotAskedConsent = 0;
	for (var i = 1 ; i <= numCases; i++)
	{
		var line = allLines[i];
		var cols = line.split(/\t/);
		var consent = cols[cols.length-1];
		var rowClass = '';
		if (consent == null || consent == 'null')
		{
			rowClass = 'consent-warning';
			numMissingConsent++;
		}
		else if (consent == 'Yes')
		{
			numYesConsent++;
		}
		else if (consent == 'No')
		{
			numNoConsent++;
		}
		else if (consent == 'Not asked')
		{
			numNotAskedConsent++;
		}
		html += '<tr class="'+rowClass+'"><td>'+cols.join('</td><td>')+'</td></tr>';
	}
	numConsentWithoutDate = numCases - numMissingConsent;

	previewTitle.innerHTML = numCases + ' Samples = ' + numConsentWithoutDate + ' unknown date (' + numYesConsent + ' Yes, ' + numNoConsent + ' No, ' + numNotAskedConsent + ' Not asked) + ' + numMissingConsent + ' missing consent';
	previewList.innerHTML = '<table>'+html+'</table>';
	Main.show('previewWrapper');
}

function createMissingDataSampleListPreview(allLines, sampleTypes, previewTitle, previewList)
{
	var numCases = allLines.length - 2; // First line is a header line
	var numSpecimen = 0;
	var numNoSpecimen = 0;
		
	var html = '<tr><th>'+allLines[0].replace(/\t/g, '</th><th>')+'</th></tr>';
	// Check second column for the 'Subtype' value
	var numNoConsent = 0;
	var numMissingConsent = 0;
	for (var i = 1 ; i <= numCases; i++)
	{
		var line = allLines[i];
		var cols = line.split(/\t/);
		var sampleSubtype = cols[1];
		if (sampleSubtype == 'Specimen')
		{
			numSpecimen++;
		}
		else if (sampleSubtype == 'NoSpecimen')
		{
			numNoSpecimen++;
		}
		var rowClass = '';
		html += '<tr class="'+rowClass+'"><td>'+cols.join('</td><td>')+'</td></tr>';
	}

	previewTitle.innerHTML = 'Sample type(s) - ' + sampleTypes + ' (' + numCases + ')';
	if (sampleTypes == 'Specimen' || sampleTypes == 'No specimen')
	{
		// Report the number of each subtype for 'Specimen/No specimen'
		previewTitle.innerHTML = 'Sample type(s) - Specimen (' + numSpecimen + ')/No specimen (' + numNoSpecimen + ') Total (' + numCases + ')';
	}
	previewList.innerHTML = '<table>'+html+'</table>';
	Main.show('previewWrapper');
}

function createItemCountReport(report, reportType)
{
	var reportTable = getReportTable();
	var sdString = report.beginDate;
	var edString = report.endDate;
	var psdString = report.periodBeginDate;
	var ldString = report.latestDate;
	var startDate = dateStrToDate(sdString);
	var endDate = dateStrToDate(edString);
	var periodStartDate = dateStrToDate(psdString);
	var latestDate = dateStrToDate(ldString);
	
	var viewType = report.viewType;		
	var sampleType = report.sampleType;
	var tableAlternatives = report.tableAlternatives;
	var bloodSampleFilter = report.bloodSampleFilter;

	var headerRow = document.createElement('tr');		
	var subHeaderRowYear = document.createElement('tr');
	var columnHeaderRow = document.createElement('tr');
	
	var headerText = '# Items by ';
	var startDateStr = addHyphensToDateString(sdString);
	var endDateStr = addHyphensToDateString(edString);
	var latestDateStr = addHyphensToDateString(ldString);
	if ('samplecount' == reportType)
	{
		headerText = '# Specimens by ';
		if ('nospecimen' == sampleType)
		{
			headerText = '# "No specimens" by ';
		}
		else if ('blood' == sampleType)
		{
			headerText = '# Blood samples by ';
			if (bloodSampleFilter != null && bloodSampleFilter != 'none')
			{
				bloodSampleFilterDisplayText = getBloodSampleFilterDisplayText(bloodSampleFilter);
				headerText = '# Blood samples of type \'' + bloodSampleFilterDisplayText + '\' by ';
			}
		}
	}
	else if ('patientcount' == reportType)
	{
		headerText = '# Patients by ';
	}
	if (viewType == 'WEEK')
	{	
		var startWeek = getISOWeekNumber(periodStartDate);
		var endWeek = getISOWeekNumber(endDate);
		var tempDate = new Date(periodStartDate.getFullYear(), periodStartDate.getMonth(), periodStartDate.getDate()-periodStartDate.getDay()+1);
		numCols = 0;
		while (tempDate < endDate)
		{
			numCols++;
			tempDate.setDate(tempDate.getDate()+7);
		}
		headerText += 'week';
	}
	else if (viewType == 'MONTH')
	{
		numCols = (endDate.getFullYear()-periodStartDate.getFullYear())*12 + endDate.getMonth()-periodStartDate.getMonth()+1;
		headerText += 'month';
	}
	else if (viewType == 'QUARTER')
	{
		// First year (from start quarter to end of year)
		numCols = 4 - Math.floor(periodStartDate.getMonth()/3);
		// Last year (from start of year to end quarter) 
		numCols += Math.floor(endDate.getMonth()/3)+1;
		// If first and last year is the same, subtract 4 quarters
		if (endDate.getFullYear() - periodStartDate.getFullYear() == 0)
		{
			numCols -= 4;
		}
		// Full years between start and end dates
		if((endDate.getFullYear() - periodStartDate.getFullYear()) > 1)
		{
			numCols += 4 * (endDate.getFullYear() - periodStartDate.getFullYear()-1);
		}
		headerText += 'quarter';
	}
	else
	{
		numCols = endDate.getFullYear() - periodStartDate.getFullYear() + 1;
		headerText += 'year';
	}
		
	// Set table header
	headerText += ' (between ' + startDateStr + ' and ' + endDateStr + ')';
	if (latestDate != null)
	{
		headerText += '\nLast registration ' + latestDateStr;
	}		
	headerRow.appendChild(getTableCellElement(headerText, 'reportheader', (numCols+5)));
	
	// Sub headers
	// Only if each datacol is less then a year
	if (viewType != 'YEAR')
	{
		subHeaderRowYear.appendChild(getTableCellElement('', 'reportsubheader', 3));
		addYearSubHeaders(periodStartDate, endDate, subHeaderRowYear, viewType);			
		subHeaderRowYear.appendChild(getTableCellElement('', 'reportsubheader', 2));
	}		
				
	// Columnsheader		
	var siteHeader = getTableCellElement('Site', 'reportsubheader');			
	var startDateHeader = getTableCellElement('Start date','reportsubheader');
	var latestDateHeader = getTableCellElement('Latest date','reportsubheader');
	columnHeaderRow.appendChild(siteHeader);
	columnHeaderRow.appendChild(startDateHeader);	
	columnHeaderRow.appendChild(latestDateHeader);	
	
	if (viewType == 'MONTH') addMonthColumnHeaders(columnHeaderRow, periodStartDate);
	else if (viewType == 'WEEK') addWeekColumnHeaders(columnHeaderRow, periodStartDate);
	else if (viewType == 'QUARTER') addQuarterColumnHeaders(columnHeaderRow, periodStartDate);
	else if (viewType == 'YEAR') addYearSubHeaders(periodStartDate, endDate, columnHeaderRow, viewType);
	
	
	columnHeaderRow.appendChild(getTableCellElement('Sum', 'reportsubheader'));
	columnHeaderRow.appendChild(getTableCellElement('Total', 'reportsubheader'));

	// Build table			
	reportTable.appendChild(headerRow);
	reportTable.appendChild(subHeaderRowYear);
	reportTable.appendChild(columnHeaderRow);
				
	// Data rows			
	addDataRowsToTable(report, reportTable);
		
	// Add a row with the combined numbers for all sites for each period
	var sitesCombinedRow = document.createElement('tr');
	sitesCombinedRow.appendChild(getTableCellElement('Sites combined', 'colsummary'));
	sitesCombinedRow.appendChild(getTableCellElement('', 'colsummary', 2));
	// Get combined numbers for all sites for each period
	var statistics = report.statistics;
	var sitesCombined = statistics.sitesCombinedKey;		
	var sortedKeyArray = createSortedPeriodArray(report, numCols);
	var key;
	for (arrayIndex in sortedKeyArray)
	{
		key = sortedKeyArray[arrayIndex];
		var data = getJSONData(sitesCombined, key, 0);
		// Add entry with sample sum for site for selected time period
		sitesCombinedRow.appendChild(getTableCellElement(data,'colsummary'));
	}
	// Get total number of samples for site for the selected time period
	var sum = getJSONData(statistics, 'sumKey', 0);
	// Add entry with total number of samples for site for the selected time period
	sitesCombinedRow.appendChild(getTableCellElement(sum, 'colsummary'));
	// Get total number of samples for all sites, regardless of creation date
	var total = getJSONData(statistics, 'totalKey', 0);
	// Add entry with total number of samples for all sites, regardless of creation date
	sitesCombinedRow.appendChild(getTableCellElement(total, 'colsummary'));
	reportTable.appendChild(sitesCombinedRow);	

	return reportTable;
}

function createConsentCountReport(report)
{
	var reportTable = getReportTable();
	var sdString = report.beginDate;
	var edString = report.endDate;
	var ldString = report.latestDate;
	var startDate = dateStrToDate(sdString);
	var endDate = dateStrToDate(edString);
	var latestDate = dateStrToDate(ldString);

	var headerRow = document.createElement('tr');		
	var subHeaderRow = document.createElement('tr');
	var columnHeaderRow = document.createElement('tr');
	
	var numCols = 5;
	var numDecimals = 0;
	var headerText = '# Consent forms of different types for cases and blood samples';
	var startDateStr = addHyphensToDateString(sdString);
	var endDateStr = addHyphensToDateString(edString);
	var latestDateStr = addHyphensToDateString(ldString);
	headerText += ' (betweeen ' + startDateStr + ' and ' + endDateStr + ')';
	if (latestDate != null)
	{
			headerText += '\nLast registration ' + latestDateStr;
	}
	headerText += '\nConsents without date treated as if belonging to selected time period';
	headerRow.appendChild(getTableCellElement(headerText, 'reportheader', (numCols+3)));
	
	// Subheader		
	subHeaderRow.appendChild(getTableCellElement('', 'reportsubheader', 3));
	
	subHeaderRow.appendChild(getTableCellElement('Yes', 'reportsubheader'));
	subHeaderRow.appendChild(getTableCellElement('No', 'reportsubheader'));
	subHeaderRow.appendChild(getTableCellElement('Not asked', 'reportsubheader'));
	subHeaderRow.appendChild(getTableCellElement('', 'reportsubheader', 2));

	// Columnsheader		
	var siteHeader = getTableCellElement('Site', 'reportsubheader');			
	var startDateHeader = getTableCellElement('Start date','reportsubheader');
	var latestDateHeader = getTableCellElement('Latest date','reportsubheader');
	columnHeaderRow.appendChild(siteHeader);
	columnHeaderRow.appendChild(startDateHeader);	
	columnHeaderRow.appendChild(latestDateHeader);	
	
	columnHeaderRow.appendChild(getTableCellElement('', 'reportsubheader'));
	columnHeaderRow.appendChild(getTableCellElement('', 'reportsubheader'));
	columnHeaderRow.appendChild(getTableCellElement('', 'reportsubheader'));
	columnHeaderRow.appendChild(getTableCellElement('Sum', 'reportsubheader'));
	columnHeaderRow.appendChild(getTableCellElement('Total', 'reportsubheader'));

	// Build table			
	reportTable.appendChild(headerRow);
	reportTable.appendChild(subHeaderRow);
	reportTable.appendChild(columnHeaderRow);
				
	// Data rows			
	addDataRowsToConsentTable(report, reportTable);
		
	// Add a row with the combined numbers for all sites for each period
	var sitesCombinedRow = document.createElement('tr');
	sitesCombinedRow.appendChild(getTableCellElement('Sites combined', 'colsummary'));
	sitesCombinedRow.appendChild(getTableCellElement('', 'colsummary', 2));
	// Get combined numbers for all sites for each period
	var noDateKey = 'noDate';
	var sumDateIgnoredKey = 'sumDateIgnoredKey';
	var statistics = report.statistics;
	var sitesCombined = statistics.sitesCombinedKey;
	if (sitesCombined != null)
	{
		data = getJSONDataWithPercent(sitesCombined, 'yes', sumDateIgnoredKey, numDecimals);
		sitesCombinedRow.appendChild(getTableCellElement(data, 'colsummary'));
		data = getJSONDataWithPercent(sitesCombined, 'no', sumDateIgnoredKey, numDecimals);
		sitesCombinedRow.appendChild(getTableCellElement(data, 'colsummary'));
		data = getJSONDataWithPercent(sitesCombined, 'notAsked', sumDateIgnoredKey, numDecimals);
		sitesCombinedRow.appendChild(getTableCellElement(data, 'colsummary'));
	}
	// Add entry with total number of consents with chosen restrictions
	data = getJSONData(sitesCombined, sumDateIgnoredKey, 0);
	sitesCombinedRow.appendChild(getTableCellElement(data, 'colsummary'));
	// Add entry with total number of consents, regardless of restrictions
	var totalKey = 'totalKey';
	data = getJSONData(sitesCombined, totalKey, 0);
	sitesCombinedRow.appendChild(getTableCellElement(data, 'colsummary'));
	reportTable.appendChild(sitesCombinedRow);	

	return reportTable;
}

function createConsentCountHasDateTable(report)
{
	var reportTable = getReportTable();
	var sdString = report.beginDate;
	var edString = report.endDate;
	var ldString = report.latestDate;
	var startDate = dateStrToDate(sdString);
	var endDate = dateStrToDate(edString);
	var latestDate = dateStrToDate(ldString);

	var headerRow = document.createElement('tr');		
	var subHeaderRow = document.createElement('tr');
	var columnHeaderRow = document.createElement('tr');
	
	var numCols = 5;
	var numDecimals = 0;
	var headerText = '# Consent forms of different types for cases and blood samples';
	var startDateStr = addHyphensToDateString(sdString);
	var endDateStr = addHyphensToDateString(edString);
	var latestDateStr = addHyphensToDateString(ldString);
	headerText += ' (betweeen ' + startDateStr + ' and ' + endDateStr + ')';
	if (latestDate != null)
	{
			headerText += '\nLast registration ' + latestDateStr;
	}
	headerRow.appendChild(getTableCellElement(headerText, 'reportheader', (numCols+5)));
	
	// Subheader		
	subHeaderRow.appendChild(getTableCellElement('', 'reportsubheader', 3));
	
	subHeaderRow.appendChild(getTableCellElement('Yes', 'reportsubheader'));
	subHeaderRow.appendChild(getTableCellElement('Yes', 'reportsubheader'));
	subHeaderRow.appendChild(getTableCellElement('No', 'reportsubheader'));
	subHeaderRow.appendChild(getTableCellElement('Not asked', 'reportsubheader'));
	subHeaderRow.appendChild(getTableCellElement('Unknown date', 'reportsubheader'));
	subHeaderRow.appendChild(getTableCellElement('', 'reportsubheader', 2));

	// Columnsheader		
	var siteHeader = getTableCellElement('Site', 'reportsubheader');			
	var startDateHeader = getTableCellElement('Start date','reportsubheader');
	var latestDateHeader = getTableCellElement('Latest date','reportsubheader');
	columnHeaderRow.appendChild(siteHeader);
	columnHeaderRow.appendChild(startDateHeader);	
	columnHeaderRow.appendChild(latestDateHeader);	
	
	columnHeaderRow.appendChild(getTableCellElement('(has PAT#)', 'reportsubheader'));
	columnHeaderRow.appendChild(getTableCellElement('(no PAT#)', 'reportsubheader'));
	columnHeaderRow.appendChild(getTableCellElement('(has date)', 'reportsubheader'));
	columnHeaderRow.appendChild(getTableCellElement('(has date)', 'reportsubheader'));
	columnHeaderRow.appendChild(getTableCellElement('', 'reportsubheader'));
	columnHeaderRow.appendChild(getTableCellElement('Sum', 'reportsubheader'));
	columnHeaderRow.appendChild(getTableCellElement('Total', 'reportsubheader'));

	// Build table			
	reportTable.appendChild(headerRow);
	reportTable.appendChild(subHeaderRow);
	reportTable.appendChild(columnHeaderRow);
				
	// Data rows			
	addDataRowsToConsentTableHasDate(report, reportTable);
		
	// Add a row with the combined numbers for all sites for each period
	var sitesCombinedRow = document.createElement('tr');
	sitesCombinedRow.appendChild(getTableCellElement('Sites combined', 'colsummary'));
	sitesCombinedRow.appendChild(getTableCellElement('', 'colsummary', 2));
	// Get combined numbers for all sites for each period
	var noDateKey = 'noDate';
	var sumKey = 'sumKey';
	var statistics = report.statistics;
	var sitesCombined = statistics.sitesCombinedKey;
	if (sitesCombined != null)
	{
		data = getJSONDataWithPercent(sitesCombined, 'yesPatientExistsDateExists', sumKey, numDecimals);
		sitesCombinedRow.appendChild(getTableCellElement(data, 'colsummary'));
		data = getJSONDataWithPercent(sitesCombined, 'yesPatientUnknownDateExists', sumKey, numDecimals);
		sitesCombinedRow.appendChild(getTableCellElement(data, 'colsummary'));
		data = getJSONDataWithPercent(sitesCombined, 'noDateExists', sumKey, numDecimals);
		sitesCombinedRow.appendChild(getTableCellElement(data, 'colsummary'));
		data = getJSONDataWithPercent(sitesCombined, 'notAskedDateExists', sumKey, numDecimals);
		sitesCombinedRow.appendChild(getTableCellElement(data, 'colsummary'));
		data = getJSONDataWithPercent(sitesCombined, noDateKey, sumKey, numDecimals);
		sitesCombinedRow.appendChild(getTableCellElement(data, 'colsummary'));
	}
	// Add entry with total number of consents with chosen restrictions
	data = getJSONData(sitesCombined, sumKey, 0);
	sitesCombinedRow.appendChild(getTableCellElement(data, 'colsummary'));
	// Add entry with total number of consents, regardless of restrictions
	var totalKey = 'totalKey';
	data = getJSONData(sitesCombined, totalKey, 0);
	sitesCombinedRow.appendChild(getTableCellElement(data, 'colsummary'));
	reportTable.appendChild(sitesCombinedRow);	

	return reportTable;
}

function createConsentCountUnknownDateTable(report)
{
	var reportTable = getReportTable();
	var headerRow = document.createElement('tr');		
	var subHeaderRow = document.createElement('tr');
	var columnHeaderRow = document.createElement('tr');
	
	var numCols = 4;
	var numDecimals = 0;
	var headerText = '# Consent forms of different types for cases and blood samples with unknown consent date, as well as items with missing consents';
	headerRow.appendChild(getTableCellElement(headerText, 'reportheader', (numCols+5)));
	
	// Subheader		
	subHeaderRow.appendChild(getTableCellElement('', 'reportsubheader', 3));
	
	subHeaderRow.appendChild(getTableCellElement('Yes', 'reportsubheader'));
	subHeaderRow.appendChild(getTableCellElement('No', 'reportsubheader'));
	subHeaderRow.appendChild(getTableCellElement('Not asked', 'reportsubheader'));
	subHeaderRow.appendChild(getTableCellElement('Missing', 'reportsubheader'));
	subHeaderRow.appendChild(getTableCellElement('', 'reportsubheader', 2));

	// Columnsheader		
	var siteHeader = getTableCellElement('Site', 'reportsubheader');			
	var startDateHeader = getTableCellElement('Start date','reportsubheader');
	var latestDateHeader = getTableCellElement('Latest date','reportsubheader');
	columnHeaderRow.appendChild(siteHeader);
	columnHeaderRow.appendChild(startDateHeader);	
	columnHeaderRow.appendChild(latestDateHeader);	
	
	columnHeaderRow.appendChild(getTableCellElement('(no date)', 'reportsubheader'));
	columnHeaderRow.appendChild(getTableCellElement('(no date)', 'reportsubheader'));
	columnHeaderRow.appendChild(getTableCellElement('(no date)', 'reportsubheader'));
	columnHeaderRow.appendChild(getTableCellElement('', 'reportsubheader'));
	columnHeaderRow.appendChild(getTableCellElement('Sum', 'reportsubheader'));
	columnHeaderRow.appendChild(getTableCellElement('Total', 'reportsubheader'));

	// Build table			
	reportTable.appendChild(headerRow);
	reportTable.appendChild(subHeaderRow);
	reportTable.appendChild(columnHeaderRow);
				
	// Data rows			
	addDataRowsToConsentTableUnknownDate(report, reportTable);
		
	// Add a row with the combined numbers for all sites
	var sitesCombinedRow = document.createElement('tr');
	sitesCombinedRow.appendChild(getTableCellElement('Sites combined', 'colsummary'));
	sitesCombinedRow.appendChild(getTableCellElement('', 'colsummary', 2));
	// Get combined numbers for all sites
	var noDateOrMissingKey = 'noDateOrMissing';
	var sumKey = 'sumKey';
	var statistics = report.statistics;
	var sitesCombined = statistics.sitesCombinedKey;
	if (sitesCombined != null)
	{
		data = getJSONDataWithPercent(sitesCombined, 'yesDateUnknown', noDateOrMissingKey, numDecimals);
		sitesCombinedRow.appendChild(getTableCellElement(data, 'colsummary'));
		data = getJSONDataWithPercent(sitesCombined, 'noDateUnknown', noDateOrMissingKey, numDecimals);
		sitesCombinedRow.appendChild(getTableCellElement(data, 'colsummary'));
		data = getJSONDataWithPercent(sitesCombined, 'notAskedDateUnknown', noDateOrMissingKey, numDecimals);
		sitesCombinedRow.appendChild(getTableCellElement(data, 'colsummary'));
		data = getJSONDataWithPercent(sitesCombined, 'missing', noDateOrMissingKey, numDecimals);
		sitesCombinedRow.appendChild(getTableCellElement(data, 'colsummary'));
		// Add entry with total number of consents with chosen restrictions
		var noDateOrMissingKey = 'noDateOrMissing';
		data = getJSONData(sitesCombined, noDateOrMissingKey, 0);
		sitesCombinedRow.appendChild(getTableCellElement(data, 'colsummary'));
		// Add entry with total number of consents, regardless of restrictions
		var totalKey = 'totalKey';
		data = getJSONData(sitesCombined, totalKey, 0);
		sitesCombinedRow.appendChild(getTableCellElement(data, 'colsummary'));
	}
	reportTable.appendChild(sitesCombinedRow);	

	return reportTable;
}

function createOverviewReport(report)
{
	var reportTable = getReportTable();
	var bloodSampleFilter = report.bloodSampleFilter;
	var sdString = report.beginDate;
	var edString = report.endDate;
	var ldString = report.latestDate;
	var startDate = dateStrToDate(sdString);
	var endDate = dateStrToDate(edString);
	var latestDate = dateStrToDate(ldString);

	var headerRow = document.createElement('tr');		
	var subHeaderRow = document.createElement('tr');
	var subHeader2Row = document.createElement('tr');
	var columnHeaderRow = document.createElement('tr');
	
	var numCols = 7;
	var numDecimals = 0;
	var headerText = 'Number of items of different kinds';
	if (bloodSampleFilter != null && bloodSampleFilter != 'none')
	{
		bloodSampleFilterDisplayText = getBloodSampleFilterDisplayText(bloodSampleFilter);
		headerText += ', blood sample type = \'' + bloodSampleFilterDisplayText + '\'';
	}
	var startDateStr = addHyphensToDateString(sdString);
	var endDateStr = addHyphensToDateString(edString);
	var latestDateStr = addHyphensToDateString(ldString);
	headerText += ' (betweeen ' + startDateStr + ' and ' + endDateStr + ')';
	if (latestDate != null)
	{
			headerText += '\nLast registration ' + latestDateStr;
	}
	headerRow.appendChild(getTableCellElement(headerText, 'reportheader', (numCols+3)));
	
	// Subheader
	subHeaderRow.appendChild(getTableCellElement('', 'reportsubheader', 3));
	
	subHeaderRow.appendChild(getTableCellElement('Patients', 'reportsubheader'));
	subHeaderRow.appendChild(getTableCellElement('Blood', 'reportsubheader'));
	subHeaderRow.appendChild(getTableCellElement('Blood', 'reportsubheader'));
	subHeaderRow.appendChild(getTableCellElement('Specimens', 'reportsubheader'));
	subHeaderRow.appendChild(getTableCellElement('No specimens', 'reportsubheader'));
	subHeaderRow.appendChild(getTableCellElement('Consents', 'reportsubheader'));
	subHeaderRow.appendChild(getTableCellElement('Consents', 'reportsubheader'));

	// Subheader 2
	subHeader2Row.appendChild(getTableCellElement('', 'reportsubheader', 3));
	
	subHeader2Row.appendChild(getTableCellElement('', 'reportsubheader'));
	subHeader2Row.appendChild(getTableCellElement('samples', 'reportsubheader'));
	subHeader2Row.appendChild(getTableCellElement('samples', 'reportsubheader'));
	subHeader2Row.appendChild(getTableCellElement('', 'reportsubheader'));
	subHeader2Row.appendChild(getTableCellElement('', 'reportsubheader'));
	subHeader2Row.appendChild(getTableCellElement('(Yes)', 'reportsubheader'));
	subHeader2Row.appendChild(getTableCellElement('missing', 'reportsubheader'));

	// Columnsheader		
	var siteHeader = getTableCellElement('Site', 'reportsubheader');			
	var startDateHeader = getTableCellElement('Start date','reportsubheader');
	var latestDateHeader = getTableCellElement('Latest date','reportsubheader');
	columnHeaderRow.appendChild(siteHeader);
	columnHeaderRow.appendChild(startDateHeader);	
	columnHeaderRow.appendChild(latestDateHeader);	
	
	columnHeaderRow.appendChild(getTableCellElement('', 'reportsubheader'));
	columnHeaderRow.appendChild(getTableCellElement('', 'reportsubheader'));
	columnHeaderRow.appendChild(getTableCellElement('follow-up', 'reportsubheader'));
	columnHeaderRow.appendChild(getTableCellElement('', 'reportsubheader'));
	columnHeaderRow.appendChild(getTableCellElement('', 'reportsubheader'));
	columnHeaderRow.appendChild(getTableCellElement('', 'reportsubheader'));
	columnHeaderRow.appendChild(getTableCellElement('', 'reportsubheader'));

	// Build table			
	reportTable.appendChild(headerRow);
	reportTable.appendChild(subHeaderRow);
	reportTable.appendChild(subHeader2Row);
	reportTable.appendChild(columnHeaderRow);
				
	// Data rows			
	addDataRowsToOverviewTable(report, reportTable);
		
	// Add a row with the combined numbers for all sites for each period
	var sitesCombinedRow = document.createElement('tr');
	sitesCombinedRow.appendChild(getTableCellElement('Sites combined', 'colsummary'));
	sitesCombinedRow.appendChild(getTableCellElement('', 'colsummary', 2));
	// Get combined numbers for all sites for each period
	var noDateKey = 'noDate';
	var sumKey = 'sumKey';
	var statistics = report.statistics;
	// Get values for use in summary section
	numPatientsNoSamples = statistics.patientNoSamples;
	var sitesCombined = statistics.sitesCombinedKey;
	if (sitesCombined != null)
	{
		data = getJSONData(sitesCombined, 'patient');
		sitesCombinedRow.appendChild(getTableCellElement(data, 'colsummary'));
		data = getJSONData(sitesCombined, 'bloodSample');
		sitesCombinedRow.appendChild(getTableCellElement(data, 'colsummary'));
		data = getJSONData(sitesCombined, 'bloodSampleFollowUp');
		sitesCombinedRow.appendChild(getTableCellElement(data, 'colsummary'));
		data = getJSONData(sitesCombined, 'specimen');
		sitesCombinedRow.appendChild(getTableCellElement(data, 'colsummary'));
		data = getJSONData(sitesCombined, 'noSpecimen');
		sitesCombinedRow.appendChild(getTableCellElement(data, 'colsummary'));
		data = getJSONData(sitesCombined, 'consentYes');
		sitesCombinedRow.appendChild(getTableCellElement(data, 'colsummary'));
		data = getJSONData(sitesCombined, 'consentMissing');
		sitesCombinedRow.appendChild(getTableCellElement(data, 'colsummary'));
	}
	reportTable.appendChild(sitesCombinedRow);	

	return reportTable;
}

function createOverviewPatientWithSampleTable(report)
{
	var reportTable = getReportTable();
	var bloodSampleFilter = report.bloodSampleFilter;
	var sdString = report.beginDate;
	var edString = report.endDate;
	var ldString = report.latestDate;
	var startDate = dateStrToDate(sdString);
	var endDate = dateStrToDate(edString);
	var latestDate = dateStrToDate(ldString);

	var headerRow = document.createElement('tr');		
	var subHeaderRow = document.createElement('tr');
	var subHeader2Row = document.createElement('tr');
	var columnHeaderRow = document.createElement('tr');
	
	var numCols = 7;
	var numDecimals = 0;
	var headerText = 'Patients having a sample type item';
	if (bloodSampleFilter != null && bloodSampleFilter != 'none')
	{
		bloodSampleFilterDisplayText = getBloodSampleFilterDisplayText(bloodSampleFilter);
		headerText += ', blood sample type = \'' + bloodSampleFilterDisplayText + '\'';
	}
	var startDateStr = addHyphensToDateString(sdString);
	var endDateStr = addHyphensToDateString(edString);
	var latestDateStr = addHyphensToDateString(ldString);
	headerText += ' (betweeen ' + startDateStr + ' and ' + endDateStr + ')';
	headerText += '\nColumn entries are non-exclusive, i.e. a patient may be represented in several columns';
	headerRow.appendChild(getTableCellElement(headerText, 'reportheader', (numCols+3)));
	
	// Subheader
	subHeaderRow.appendChild(getTableCellElement('', 'reportsubheader', 3));
	
	subHeaderRow.appendChild(getTableCellElement('Patients', 'reportsubheader'));
	subHeaderRow.appendChild(getTableCellElement('with', 'reportsubheader'));
	subHeaderRow.appendChild(getTableCellElement('with', 'reportsubheader'));
	subHeaderRow.appendChild(getTableCellElement('with', 'reportsubheader'));
	subHeaderRow.appendChild(getTableCellElement('with', 'reportsubheader'));
	subHeaderRow.appendChild(getTableCellElement('', 'reportsubheader'));
	subHeaderRow.appendChild(getTableCellElement('', 'reportsubheader'));

	// Subheader 2
	subHeader2Row.appendChild(getTableCellElement('', 'reportsubheader', 3));
	
	subHeader2Row.appendChild(getTableCellElement('total', 'reportsubheader'));
	subHeader2Row.appendChild(getTableCellElement('blood', 'reportsubheader'));
	subHeader2Row.appendChild(getTableCellElement('follow-up', 'reportsubheader'));
	subHeader2Row.appendChild(getTableCellElement('specimen(s)', 'reportsubheader'));
	subHeader2Row.appendChild(getTableCellElement('no specimen(s)', 'reportsubheader'));
	subHeader2Row.appendChild(getTableCellElement('', 'reportsubheader'));
	subHeader2Row.appendChild(getTableCellElement('', 'reportsubheader'));

	// Columnsheader		
	var siteHeader = getTableCellElement('Site', 'reportsubheader');			
	var startDateHeader = getTableCellElement('Start date','reportsubheader');
	var latestDateHeader = getTableCellElement('Latest date','reportsubheader');
	columnHeaderRow.appendChild(siteHeader);
	columnHeaderRow.appendChild(startDateHeader);	
	columnHeaderRow.appendChild(latestDateHeader);	
	
	columnHeaderRow.appendChild(getTableCellElement('', 'reportsubheader'));
	columnHeaderRow.appendChild(getTableCellElement('sample(s)', 'reportsubheader'));
	columnHeaderRow.appendChild(getTableCellElement('blood s.', 'reportsubheader'));
	columnHeaderRow.appendChild(getTableCellElement('', 'reportsubheader'));
	columnHeaderRow.appendChild(getTableCellElement('', 'reportsubheader'));
	columnHeaderRow.appendChild(getTableCellElement('', 'reportsubheader'));
	columnHeaderRow.appendChild(getTableCellElement('', 'reportsubheader'));

	// Build table			
	reportTable.appendChild(headerRow);
	reportTable.appendChild(subHeaderRow);
	reportTable.appendChild(subHeader2Row);
	reportTable.appendChild(columnHeaderRow);
				
	// Data rows			
	addDataRowsToOverviewPatientWithSampleTable(report, reportTable);
		
	// Add a row with the combined numbers for all sites for each period
	var sitesCombinedRow = document.createElement('tr');
	sitesCombinedRow.appendChild(getTableCellElement('Sites combined', 'colsummary'));
	sitesCombinedRow.appendChild(getTableCellElement('', 'colsummary', 2));
	// Get combined numbers for all sites for each period
	var noDateKey = 'noDate';
	var sumKey = 'sumKey';
	var statistics = report.statistics;
	// Get values for use in summary section
	numPatientsNoSamples = statistics.patientNoSamples;
	var sitesCombined = statistics.sitesCombinedKey;
	if (sitesCombined != null)
	{
		data = getJSONData(sitesCombined, 'patient');
		sitesCombinedRow.appendChild(getTableCellElement(data, 'colsummary'));
		data = getJSONData(sitesCombined, 'patientWithBloodSample');
		sitesCombinedRow.appendChild(getTableCellElement(data, 'colsummary'));
		data = getJSONData(sitesCombined, 'patientWithFollowUpBloodSample');
		sitesCombinedRow.appendChild(getTableCellElement(data, 'colsummary'));
		data = getJSONData(sitesCombined, 'patientWithSpecimen');
		sitesCombinedRow.appendChild(getTableCellElement(data, 'colsummary'));
		data = getJSONData(sitesCombined, 'patientWithNoSpecimen');
		sitesCombinedRow.appendChild(getTableCellElement(data, 'colsummary'));
	}
	reportTable.appendChild(sitesCombinedRow);	

	return reportTable;
}

function createOverviewPatientDetailedTable(report)
{
	var reportTable = getReportTable();
	var bloodSampleFilter = report.bloodSampleFilter;
	var sdString = report.beginDate;
	var edString = report.endDate;
	var ldString = report.latestDate;
	var startDate = dateStrToDate(sdString);
	var endDate = dateStrToDate(edString);

	var headerRow = document.createElement('tr');		
	var subHeaderRow = document.createElement('tr');
	var subHeader2Row = document.createElement('tr');
	var columnHeaderRow = document.createElement('tr');
	
	var numCols = 8;
	var numDecimals = 0;
	var headerText = 'Patient records of different kinds';
	if (bloodSampleFilter != null && bloodSampleFilter != 'none')
	{
		bloodSampleFilterDisplayText = getBloodSampleFilterDisplayText(bloodSampleFilter);
		headerText += ', blood sample type = \'' + bloodSampleFilterDisplayText + '\'';
	}
	var startDateStr = addHyphensToDateString(sdString);
	var endDateStr = addHyphensToDateString(edString);
	var latestDateStr = addHyphensToDateString(ldString);
	headerText += ' (betweeen ' + startDateStr + ' and ' + endDateStr + ')';
/*
	if (latestDate != null)
	{
			headerText += '\nLast registration ' + latestDateStr;
	}
*/
	headerRow.appendChild(getTableCellElement(headerText, 'reportheader', (numCols+2)));
	
	// Subheader
	subHeaderRow.appendChild(getTableCellElement('', 'reportsubheader', 2));
	
	subHeaderRow.appendChild(getTableCellElement('Patients', 'reportsubheader'));
	subHeaderRow.appendChild(getTableCellElement('Patients', 'reportsubheader'));
	subHeaderRow.appendChild(getTableCellElement('Patients', 'reportsubheader'));
	subHeaderRow.appendChild(getTableCellElement('Patients', 'reportsubheader'));
	subHeaderRow.appendChild(getTableCellElement('Patients', 'reportsubheader'));
	subHeaderRow.appendChild(getTableCellElement('Patients', 'reportsubheader'));
	subHeaderRow.appendChild(getTableCellElement('Patients', 'reportsubheader'));
	//subHeaderRow.appendChild(getTableCellElement('Patients', 'reportsubheader'));
	subHeaderRow.appendChild(getTableCellElement('', 'reportsubheader'));

	// Subheader 2
	subHeader2Row.appendChild(getTableCellElement('', 'reportsubheader', 2));
	
	subHeader2Row.appendChild(getTableCellElement('(blood', 'reportsubheader'));
	subHeader2Row.appendChild(getTableCellElement('(spec.', 'reportsubheader'));
	subHeader2Row.appendChild(getTableCellElement('(no spec.', 'reportsubheader'));
	subHeader2Row.appendChild(getTableCellElement('(blood and', 'reportsubheader'));
	subHeader2Row.appendChild(getTableCellElement('(blood and', 'reportsubheader'));
	subHeader2Row.appendChild(getTableCellElement('(spec. and', 'reportsubheader'));
	subHeader2Row.appendChild(getTableCellElement('(blood, spec.,', 'reportsubheader'));
	//subHeader2Row.appendChild(getTableCellElement('(no samples)', 'reportsubheader'));
	subHeader2Row.appendChild(getTableCellElement('', 'reportsubheader'));

	// Columnsheader		
	var siteHeader = getTableCellElement('Site', 'reportsubheader');			
	var startDateHeader = getTableCellElement('Start date','reportsubheader');
	//var latestDateHeader = getTableCellElement('Latest date','reportsubheader');
	columnHeaderRow.appendChild(siteHeader);
	columnHeaderRow.appendChild(startDateHeader);	
	//columnHeaderRow.appendChild(latestDateHeader);	
	
	columnHeaderRow.appendChild(getTableCellElement('only)', 'reportsubheader'));
	columnHeaderRow.appendChild(getTableCellElement('only)', 'reportsubheader'));
	columnHeaderRow.appendChild(getTableCellElement('only)', 'reportsubheader'));
	columnHeaderRow.appendChild(getTableCellElement('specimens)', 'reportsubheader'));
	columnHeaderRow.appendChild(getTableCellElement('no spec.)', 'reportsubheader'));
	columnHeaderRow.appendChild(getTableCellElement('no spec.)', 'reportsubheader'));
	columnHeaderRow.appendChild(getTableCellElement('and no spec.)', 'reportsubheader'));
	//columnHeaderRow.appendChild(getTableCellElement('', 'reportsubheader'));

	columnHeaderRow.appendChild(getTableCellElement('Sum', 'reportsubheader'));

	// Build table			
	reportTable.appendChild(headerRow);
	reportTable.appendChild(subHeaderRow);
	reportTable.appendChild(subHeader2Row);
	reportTable.appendChild(columnHeaderRow);
				
	// Data rows			
	addDataRowsToOverviewPatientDetailedTable(report, reportTable);
		
	// Add a row with the combined numbers for all sites
	var sitesCombinedRow = document.createElement('tr');
	sitesCombinedRow.appendChild(getTableCellElement('Sites combined', 'colsummary'));
	sitesCombinedRow.appendChild(getTableCellElement('', 'colsummary'));
	// Get combined numbers for all sites
	var noDateKey = 'noDate';
	var sumKey = 'sumKey';
	var statistics = report.statistics;
	// Get values for use in summary section
	numPatientsNoSamples = statistics.patientNoSamples;
	var sitesCombined = statistics.sitesCombinedKey;
	if (sitesCombined != null)
	{
		data = getJSONData(sitesCombined, 'patientBloodSampleOnly');
		sitesCombinedRow.appendChild(getTableCellElement(data, 'colsummary'));
		data = getJSONData(sitesCombined, 'patientSpecimenOnly');
		sitesCombinedRow.appendChild(getTableCellElement(data, 'colsummary'));
		data = getJSONData(sitesCombined, 'patientNoSpecimenOnly');
		sitesCombinedRow.appendChild(getTableCellElement(data, 'colsummary'));
		data = getJSONData(sitesCombined, 'patientBloodSampleAndSpecimen');
		sitesCombinedRow.appendChild(getTableCellElement(data, 'colsummary'));
		data = getJSONData(sitesCombined, 'patientBloodSampleAndNoSpecimen');
		sitesCombinedRow.appendChild(getTableCellElement(data, 'colsummary'));
		data = getJSONData(sitesCombined, 'patientSpecimenAndNoSpecimen');
		sitesCombinedRow.appendChild(getTableCellElement(data, 'colsummary'));
		data = getJSONData(sitesCombined, 'patientBloodSampleAndSpecimenAndNoSpecimen');
		sitesCombinedRow.appendChild(getTableCellElement(data, 'colsummary'));
		//data = getJSONData(sitesCombined, 'patientNoSamples');
		//sitesCombinedRow.appendChild(getTableCellElement(data, 'colsummary'));
		data = getJSONData(sitesCombined, 'sumKey');
		sitesCombinedRow.appendChild(getTableCellElement(data, 'colsummary'));
	}
	reportTable.appendChild(sitesCombinedRow);	

	return reportTable;
}

function createMissingSampleDataReport(report)
{
	var reportTable = getReportTable();
	var sdString = report.beginDate;
	var edString = report.endDate;
	var ldString = report.latestDate;
	var startDate = dateStrToDate(sdString);
	var endDate = dateStrToDate(edString);
	var latestDate = dateStrToDate(ldString);

	var sampleType = report.sampleType;
	var bloodSampleFilter = report.bloodSampleFilter;
	var permissionDeniedForPatientName = report.permissionDeniedForPatientName;
	var permissionDeniedForPad = report.permissionDeniedForPad;

	var headerRow = document.createElement('tr');		
	var subHeaderRow = document.createElement('tr');
	var subHeader2Row = document.createElement('tr');
	var columnHeaderRow = document.createElement('tr');
	
	var numCols = 5;
	if (sampleType == 'specimen')
	{
		numCols = 5;
	}
	else if (sampleType == 'nospecimen')
	{
		numCols = 4;
	}
	else if (sampleType == 'blood')
	{
		numCols = 3;
	}
	var numDecimals = 0;
	var headerText = 'Number of missing specimen items of different kinds';
	if ('nospecimen' == sampleType)
	{
		headerText = 'Number of missing "no specimen" items of different kinds';
	}
	else if ('blood' == sampleType)
	{
		headerText = 'Number of missing blood sample items of different kinds';
		if (bloodSampleFilter != null && bloodSampleFilter != 'none')
		{
			bloodSampleFilterDisplayText = getBloodSampleFilterDisplayText(bloodSampleFilter);
			headerText += ', blood sample type = \'' + bloodSampleFilterDisplayText + '\'';
		}
	}
	var startDateStr = addHyphensToDateString(sdString);
	var endDateStr = addHyphensToDateString(edString);
	var latestDateStr = addHyphensToDateString(ldString);
	headerText += ' (betweeen ' + startDateStr + ' and ' + endDateStr + ')';
	if (latestDate != null)
	{
			headerText += '\nLast registration ' + latestDateStr;
	}
	headerRow.appendChild(getTableCellElement(headerText, 'reportheader', (numCols+3)));
	
	// Subheader
	subHeaderRow.appendChild(getTableCellElement('', 'reportsubheader', 3));
	
	subHeaderRow.appendChild(getTableCellElement('Patient', 'reportsubheader'));
	if (sampleType == 'specimen')
	{
		subHeaderRow.appendChild(getTableCellElement('PAD', 'reportsubheader'));
		subHeaderRow.appendChild(getTableCellElement('Laterality', 'reportsubheader'));
		subHeaderRow.appendChild(getTableCellElement('Sampling', 'reportsubheader'));
		subHeaderRow.appendChild(getTableCellElement('RNALater', 'reportsubheader'));
	}
	else if (sampleType == 'nospecimen')
	{
		subHeaderRow.appendChild(getTableCellElement('PAD', 'reportsubheader'));
		subHeaderRow.appendChild(getTableCellElement('Laterality', 'reportsubheader'));
		subHeaderRow.appendChild(getTableCellElement('Sampling', 'reportsubheader'));
	}
	else if (sampleType == 'blood')
	{
		subHeaderRow.appendChild(getTableCellElement('Blood sampling', 'reportsubheader'));
		subHeaderRow.appendChild(getTableCellElement('Blood freezer', 'reportsubheader'));
	}

	// Columnsheader		
	var siteHeader = getTableCellElement('Site', 'reportsubheader');			
	var startDateHeader = getTableCellElement('Start date','reportsubheader');
	var latestDateHeader = getTableCellElement('Latest date','reportsubheader');
	columnHeaderRow.appendChild(siteHeader);
	columnHeaderRow.appendChild(startDateHeader);	
	columnHeaderRow.appendChild(latestDateHeader);	
	
	columnHeaderRow.appendChild(getTableCellElement('name', 'reportsubheader'));
	if (sampleType == 'specimen')
	{
		columnHeaderRow.appendChild(getTableCellElement('reference', 'reportsubheader'));
		columnHeaderRow.appendChild(getTableCellElement('', 'reportsubheader'));
		columnHeaderRow.appendChild(getTableCellElement('date', 'reportsubheader'));
		columnHeaderRow.appendChild(getTableCellElement('date', 'reportsubheader'));
	}
	else if (sampleType == 'nospecimen')
	{
		columnHeaderRow.appendChild(getTableCellElement('reference', 'reportsubheader'));
		columnHeaderRow.appendChild(getTableCellElement('', 'reportsubheader'));
		columnHeaderRow.appendChild(getTableCellElement('date', 'reportsubheader'));
	}
	else if (sampleType == 'blood')
	{
		columnHeaderRow.appendChild(getTableCellElement('date', 'reportsubheader'));
		columnHeaderRow.appendChild(getTableCellElement('date', 'reportsubheader'));
	}

	// Build table			
	reportTable.appendChild(headerRow);
	reportTable.appendChild(subHeaderRow);
	reportTable.appendChild(columnHeaderRow);
				
	// Data rows			
	addDataRowsToMissingSampleDataTable(report, reportTable);
		
	// Add a row with the combined numbers for all sites for each period
	var sitesCombinedRow = document.createElement('tr');
	sitesCombinedRow.appendChild(getTableCellElement('Sites combined', 'colsummary'));
	sitesCombinedRow.appendChild(getTableCellElement('', 'colsummary', 2));
	// Get combined numbers for all sites for each period
	var noDateKey = 'noDate';
	var sumKey = 'sumKey';
	var statistics = report.statistics;
	var sitesCombined = statistics.sitesCombinedKey;
	if (sitesCombined != null)
	{
		if (!permissionDeniedForPatientName)
		{
			data = getJSONData(sitesCombined, 'missingPatientName');
			sitesCombinedRow.appendChild(getTableCellElement(data, 'colsummary'));
		}
		else
		{
			data = '-';
			sitesCombinedRow.appendChild(getTableCellElement(data, 'colsummary'));
		}
		if (sampleType == 'specimen')
		{
			if (!permissionDeniedForPad)
			{
				data = getJSONData(sitesCombined, 'missingPadReference');
				sitesCombinedRow.appendChild(getTableCellElement(data, 'colsummary'));
			}
			else
			{
				data = '-';
				sitesCombinedRow.appendChild(getTableCellElement(data, 'colsummary'));
			}
			data = getJSONData(sitesCombined, 'missingLaterality');
			sitesCombinedRow.appendChild(getTableCellElement(data, 'colsummary'));
			data = getJSONData(sitesCombined, 'missingSamplingDateTime');
			sitesCombinedRow.appendChild(getTableCellElement(data, 'colsummary'));
			data = getJSONData(sitesCombined, 'missingRnaLaterDateTime');
			sitesCombinedRow.appendChild(getTableCellElement(data, 'colsummary'));
		}
		else if (sampleType == 'nospecimen')
		{
			if (!permissionDeniedForPad)
			{
				data = getJSONData(sitesCombined, 'missingPadReference');
				sitesCombinedRow.appendChild(getTableCellElement(data, 'colsummary'));
			}
			else
			{
				data = '-';
				sitesCombinedRow.appendChild(getTableCellElement(data, 'colsummary'));
			}
			data = getJSONData(sitesCombined, 'missingLaterality');
			sitesCombinedRow.appendChild(getTableCellElement(data, 'colsummary'));
			data = getJSONData(sitesCombined, 'missingSamplingDateTime');
			sitesCombinedRow.appendChild(getTableCellElement(data, 'colsummary'));
		}
		else if (sampleType == 'blood')
		{
			data = getJSONData(sitesCombined, 'missingBloodSamplingDateTime');
			sitesCombinedRow.appendChild(getTableCellElement(data, 'colsummary'));
			data = getJSONData(sitesCombined, 'missingBloodFreezerDateTime');
			sitesCombinedRow.appendChild(getTableCellElement(data, 'colsummary'));
		}
	}
	reportTable.appendChild(sitesCombinedRow);	

	return reportTable;
}

function createConsentTablePatientsWithMultipleDates(report)
{
	var multipleDatesTable = getReportTable();
	var headerRow = document.createElement('tr');		
	var columnHeaderRow = document.createElement('tr');
	
	// Table header
	var numCols = 3;
	var headerText = 'Consent forms with multiple dates for same patient';
	headerRow.appendChild(getTableCellElement(headerText, 'reportheader', numCols));
	
	// Columnsheader
	columnHeaderRow.appendChild(getTableCellElement('Patient ID', 'reportsubheader'));
	columnHeaderRow.appendChild(getTableCellElement('Date 1', 'reportsubheader'));
	columnHeaderRow.appendChild(getTableCellElement('Date 2', 'reportsubheader'));

	// Build table			
	multipleDatesTable.appendChild(headerRow);
	multipleDatesTable.appendChild(columnHeaderRow);
				
	// Data rows
	if (report != null)
	{
		var statistics = report.statistics;
		var sessionId = statistics.sessionIdKey;
		var patientsWithMultipleDates = statistics.patientsWithMultipleDatesKey;
		var patientnamePatientid = statistics.patientnamePatientidKey;
		for (var patientName in patientsWithMultipleDates)
		{
			var tableRow = document.createElement('tr');
			// Add patient name to table
			var patientIdStr = patientnamePatientid[patientName];
			var patientLink = createLink(patientName, patientIdStr, 'BIOSOURCE', 'View this sample');
			var tableCol = createTableCellElementChild(patientLink, 'reportdata');
			tableRow.appendChild(tableCol);
			// Add dates to table in chronological order
			var dateSet = patientsWithMultipleDates[patientName];
			var dateStr1 = '';
			var dateStr2 = '';
			for (var key in dateSet)
			{
				var dateStr = dateSet[key];
				if (dateStr1 == '')
				{
					dateStr1 = dateStr;
				}
				else if (dateStr > dateStr1)
				{
					dateStr2 = dateStr;
				}
				else
				{
					dateStr2 = dateStr1;
					dateStr1 = dateStr;
				}
			}
			var dateCol = '';
			dateCol = getTableCellElement(dateStr1, 'reportdata');
			tableRow.appendChild(dateCol);
			dateCol = getTableCellElement(dateStr2, 'reportdata');
			tableRow.appendChild(dateCol);
			multipleDatesTable.appendChild(tableRow);
		}
	}

	return multipleDatesTable;
}

function addDataRowsToConsentTable(report, reportTable, numDecimals)
{
	var sites = report.sites;		
	var statistics = report.statistics;
	unknownCreation = statistics.noDate;
	unknownSite = statistics.unknownSite;
	for (var siteNo = 0; siteNo < sites.length; siteNo++)
	{
		var site = sites[siteNo];
		var siteName = site.name;
		var siteStartDate = dateStrToDate(site.startDate);
		var siteStartDateStr = addHyphensToDateString(site.startDate);
		
		var siteData = statistics[site.prefix];			
		var siteLatestDate = siteData['latestDateKey'];
		var siteLatestDateStr = addHyphensToDateString(siteLatestDate);
		var tableRow = document.createElement('tr');
		var tableCol = getTableCellElement(siteName, 'rowtitle');
		tableRow.appendChild(tableCol);
		tableRow.appendChild(getTableCellElement(siteStartDateStr, 'reportdata'));
		tableRow.appendChild(getTableCellElement(siteLatestDateStr, 'reportdata'));
		var noDateKey = 'noDate';
		var sumDateIgnoredKey = 'sumDateIgnoredKey';
		var totalKey = 'totalKey';
		if (siteData != null)
		{
			data = getJSONDataWithPercent(siteData, 'yes', sumDateIgnoredKey, numDecimals);
			tableRow.appendChild(getTableCellElement(data, 'reportdata'));
			data = getJSONDataWithPercent(siteData, 'no', sumDateIgnoredKey, numDecimals);
			tableRow.appendChild(getTableCellElement(data, 'reportdata'));
			data = getJSONDataWithPercent(siteData, 'notAsked', sumDateIgnoredKey, numDecimals);
			tableRow.appendChild(getTableCellElement(data, 'reportdata'));
			// Add column with summed values for site
			var siteSum = getJSONData(siteData, sumDateIgnoredKey, 0);
			tableRow.appendChild(getTableCellElement(siteSum, 'rowsummary'));
		}
		// Add column with total number of samples for site, regardless of creation date
		var siteTotal = getJSONData(siteData, totalKey, 0);
		tableRow.appendChild(getTableCellElement(siteTotal, 'rowsummary'));
		reportTable.appendChild(tableRow);
	}
}

function addDataRowsToConsentTableHasDate(report, reportTable, numDecimals)
{
	var sites = report.sites;		
	var statistics = report.statistics;
	unknownCreation = statistics.noDate;
	unknownSite = statistics.unknownSite;
	for (var siteNo = 0; siteNo < sites.length; siteNo++)
	{
		var site = sites[siteNo];
		var siteName = site.name;
		var siteStartDate = dateStrToDate(site.startDate);
		var siteStartDateStr = addHyphensToDateString(site.startDate);
		
		var siteData = statistics[site.prefix];			
		var siteLatestDate = siteData['latestDateKey'];
		var siteLatestDateStr = addHyphensToDateString(siteLatestDate);
		var tableRow = document.createElement('tr');
		var tableCol = getTableCellElement(siteName, 'rowtitle');
		tableRow.appendChild(tableCol);
		tableRow.appendChild(getTableCellElement(siteStartDateStr, 'reportdata'));
		tableRow.appendChild(getTableCellElement(siteLatestDateStr, 'reportdata'));
		var noDateKey = 'noDate';
		var sumKey = 'sumKey';
		var totalKey = 'totalKey';
		if (siteData != null)
		{
			data = getJSONDataWithPercent(siteData, 'yesPatientExistsDateExists', sumKey, numDecimals);
			tableRow.appendChild(getTableCellElement(data, 'reportdata'));
			data = getJSONDataWithPercent(siteData, 'yesPatientUnknownDateExists', sumKey, numDecimals);
			tableRow.appendChild(getTableCellElement(data, 'reportdata'));
			data = getJSONDataWithPercent(siteData, 'noDateExists', sumKey, numDecimals);
			tableRow.appendChild(getTableCellElement(data, 'reportdata'));
			data = getJSONDataWithPercent(siteData, 'notAskedDateExists', sumKey, numDecimals);
			tableRow.appendChild(getTableCellElement(data, 'reportdata'));
			data = getJSONDataWithPercent(siteData, noDateKey, sumKey, numDecimals);
			tableRow.appendChild(getTableCellElement(data, 'reportdata'));
			// Add column with summed values for site
			var siteSum = getJSONData(siteData, sumKey, 0);
			tableRow.appendChild(getTableCellElement(siteSum, 'rowsummary'));
		}
		// Add column with total number of samples for site, regardless of creation date
		var siteTotal = getJSONData(siteData, totalKey, 0);
		tableRow.appendChild(getTableCellElement(siteTotal, 'rowsummary'));
		reportTable.appendChild(tableRow);
	}
}

function addDataRowsToConsentTableUnknownDate(report, reportTable, numDecimals)
{
	var sites = report.sites;		
	var statistics = report.statistics;
	unknownCreation = statistics.noDate;
	unknownSite = statistics.unknownSite;
	numMissing = statistics.missing;
	for (var siteNo = 0; siteNo < sites.length; siteNo++)
	{
		var site = sites[siteNo];
		var siteName = site.name;
		var siteStartDate = dateStrToDate(site.startDate);
		var siteStartDateStr = addHyphensToDateString(site.startDate);
		
		var siteData = statistics[site.prefix];			
		var siteLatestDate = siteData['latestDateKey'];
		var siteLatestDateStr = addHyphensToDateString(siteLatestDate);
		var tableRow = document.createElement('tr');
		var tableCol = getTableCellElement(siteName, 'rowtitle');
		tableRow.appendChild(tableCol);
		tableRow.appendChild(getTableCellElement(siteStartDateStr, 'reportdata'));
		tableRow.appendChild(getTableCellElement(siteLatestDateStr, 'reportdata'));
		var noDateOrMissingKey = 'noDateOrMissing';
		var sumKey = 'sumKey';
		var totalKey = 'totalKey';
		if (siteData != null)
		{
			data = getJSONDataWithPercent(siteData, 'yesDateUnknown', noDateOrMissingKey, numDecimals);
			tableRow.appendChild(getTableCellElement(data, 'reportdata'));
			data = getJSONDataWithPercent(siteData, 'noDateUnknown', noDateOrMissingKey, numDecimals);
			tableRow.appendChild(getTableCellElement(data, 'reportdata'));
			data = getJSONDataWithPercent(siteData, 'notAskedDateUnknown', noDateOrMissingKey, numDecimals);
			tableRow.appendChild(getTableCellElement(data, 'reportdata'));
			data = getJSONDataWithPercent(siteData, 'missing', noDateOrMissingKey, numDecimals);
			tableRow.appendChild(getTableCellElement(data, 'reportdata'));
			// Add column with summed values for site
			var siteSum = getJSONData(siteData, noDateOrMissingKey, 0);
			tableRow.appendChild(getTableCellElement(siteSum, 'rowsummary'));
		}
		// Add column with total number of samples for site, regardless of creation date
		var siteTotal = getJSONData(siteData, totalKey, 0);
		tableRow.appendChild(getTableCellElement(siteTotal, 'rowsummary'));
		reportTable.appendChild(tableRow);
	}
}

function addDataRowsToOverviewTable(report, reportTable)
{
	var sites = report.sites;		
	var statistics = report.statistics;
	unknownCreation = statistics.noDate;
	unknownSite = statistics.unknownSite;
	for (var siteNo = 0; siteNo < sites.length; siteNo++)
	{
		var site = sites[siteNo];
		var siteName = site.name;				
		var siteStartDate = dateStrToDate(site.startDate);
		var siteStartDateStr = addHyphensToDateString(site.startDate);
		
		var siteData = statistics[siteNo];			
		var siteLatestDate = siteData['latestDateKey'];
		var siteLatestDateStr = addHyphensToDateString(siteLatestDate);
		var tableRow = document.createElement('tr');
		var tableCol = getTableCellElement(siteName, 'rowtitle');
		tableRow.appendChild(tableCol);
		tableRow.appendChild(getTableCellElement(siteStartDateStr, 'reportdata'));
		tableRow.appendChild(getTableCellElement(siteLatestDateStr, 'reportdata'));
		var noDateKey = 'noDate';
		var sumKey = 'sumKey';
		var totalKey = 'totalKey';
		if (siteData != null)
		{
			data = getJSONData(siteData, 'patient');
			tableRow.appendChild(getTableCellElement(data, 'reportdata'));
			data = getJSONData(siteData, 'bloodSample');
			tableRow.appendChild(getTableCellElement(data, 'reportdata'));
			data = getJSONData(siteData, 'bloodSampleFollowUp');
			tableRow.appendChild(getTableCellElement(data, 'reportdata'));
			data = getJSONData(siteData, 'specimen');
			tableRow.appendChild(getTableCellElement(data, 'reportdata'));
			data = getJSONData(siteData, 'noSpecimen');
			tableRow.appendChild(getTableCellElement(data, 'reportdata'));
			data = getJSONData(siteData, 'consentYes');
			tableRow.appendChild(getTableCellElement(data, 'reportdata'));
			data = getJSONData(siteData, 'consentMissing');
			tableRow.appendChild(getTableCellElement(data, 'reportdata'));
		}
		reportTable.appendChild(tableRow);
	}
}

function addDataRowsToOverviewPatientWithSampleTable(report, reportTable)
{
	var sites = report.sites;		
	var statistics = report.statistics;
	unknownCreation = statistics.noDate;
	unknownSite = statistics.unknownSite;
	for (var siteNo = 0; siteNo < sites.length; siteNo++)
	{				
		var site = sites[siteNo];
		var siteName = site.name;				
		var siteStartDate = dateStrToDate(site.startDate);
		var siteStartDateStr = addHyphensToDateString(site.startDate);
		
		var siteData = statistics[site.prefix];			
		var siteLatestDate = siteData['latestDateKey'];
		var siteLatestDateStr = addHyphensToDateString(siteLatestDate);
		var tableRow = document.createElement('tr');
		var tableCol = getTableCellElement(siteName, 'rowtitle');
		tableRow.appendChild(tableCol);
		tableRow.appendChild(getTableCellElement(siteStartDateStr, 'reportdata'));
		tableRow.appendChild(getTableCellElement(siteLatestDateStr, 'reportdata'));
		var noDateKey = 'noDate';
		var sumKey = 'sumKey';
		var totalKey = 'totalKey';
		if (siteData != null)
		{
			data = getJSONData(siteData, 'patient');
			tableRow.appendChild(getTableCellElement(data, 'reportdata'));
			data = getJSONData(siteData, 'patientWithBloodSample');
			tableRow.appendChild(getTableCellElement(data, 'reportdata'));
			data = getJSONData(siteData, 'patientWithFollowUpBloodSample');
			tableRow.appendChild(getTableCellElement(data, 'reportdata'));
			data = getJSONData(siteData, 'patientWithSpecimen');
			tableRow.appendChild(getTableCellElement(data, 'reportdata'));
			data = getJSONData(siteData, 'patientWithNoSpecimen');
			tableRow.appendChild(getTableCellElement(data, 'reportdata'));
		}
		reportTable.appendChild(tableRow);
	}
}

function addDataRowsToOverviewPatientDetailedTable(report, reportTable)
{
	var sites = report.sites;		
	var statistics = report.statistics;
	unknownCreation = statistics.noDate;
	unknownSite = statistics.unknownSite;
	for (var siteNo = 0; siteNo < sites.length; siteNo++)
	{		
		var site = sites[siteNo];
		var siteName = site.name;				
		var siteStartDate = dateStrToDate(site.startDate);
		var siteStartDateStr = addHyphensToDateString(site.startDate);
		
		var siteData = statistics[site.prefix];
/*		
		var siteLatestDate = siteData['latestDateKey'];
		var siteLatestDateStr = addHyphensToDateString(siteLatestDate);
*/
		var tableRow = document.createElement('tr');
		var tableCol = getTableCellElement(siteName, 'rowtitle');
		tableRow.appendChild(tableCol);
		tableRow.appendChild(getTableCellElement(siteStartDateStr, 'reportdata'));
/*
		tableRow.appendChild(getTableCellElement(siteLatestDateStr, 'reportdata'));
*/
		var noDateKey = 'noDate';
		var sumKey = 'sumKey';
		var totalKey = 'totalKey';
		if (siteData != null)
		{
			data = getJSONData(siteData, 'patientBloodSampleOnly');
			tableRow.appendChild(getTableCellElement(data, 'reportdata'));
			data = getJSONData(siteData, 'patientSpecimenOnly');
			tableRow.appendChild(getTableCellElement(data, 'reportdata'));
			data = getJSONData(siteData, 'patientNoSpecimenOnly');
			tableRow.appendChild(getTableCellElement(data, 'reportdata'));
			data = getJSONData(siteData, 'patientBloodSampleAndSpecimen');
			tableRow.appendChild(getTableCellElement(data, 'reportdata'));
			data = getJSONData(siteData, 'patientBloodSampleAndNoSpecimen');
			tableRow.appendChild(getTableCellElement(data, 'reportdata'));
			data = getJSONData(siteData, 'patientSpecimenAndNoSpecimen');
			tableRow.appendChild(getTableCellElement(data, 'reportdata'));
			data = getJSONData(siteData, 'patientBloodSampleAndSpecimenAndNoSpecimen');
			tableRow.appendChild(getTableCellElement(data, 'reportdata'));
			//data = getJSONData(siteData, 'patientNoSamples');
			//tableRow.appendChild(getTableCellElement(data, 'reportdata'));
			data = getJSONData(siteData, 'sumKey');
			tableRow.appendChild(getTableCellElement(data, 'rowsummary'));
		}
		reportTable.appendChild(tableRow);
	}
}

function addDataRowsToMissingSampleDataTable(report, reportTable)
{
	var sites = report.sites;		
	var statistics = report.statistics;
	var sampleType = report.sampleType;
	var permissionDeniedForPatientName = report.permissionDeniedForPatientName;
	var permissionDeniedForPad = report.permissionDeniedForPad;
	var unknownCreation = statistics.noDate;
	var unknownSite = statistics.unknownSite;
	for (var siteNo = 0; siteNo < sites.length; siteNo++)
	{			
		var site = sites[siteNo];
		var siteName = site.name;
		var siteStartDate = dateStrToDate(site.startDate);
		var siteStartDateStr = addHyphensToDateString(site.startDate);
		
		var siteData = statistics[site.prefix];			
		var siteLatestDate = siteData['latestDateKey'];
		var siteLatestDateStr = addHyphensToDateString(siteLatestDate);
		var tableRow = document.createElement('tr');
		var tableCol = getTableCellElement(siteName, 'rowtitle');
		tableRow.appendChild(tableCol);
		tableRow.appendChild(getTableCellElement(siteStartDateStr, 'reportdata'));
		tableRow.appendChild(getTableCellElement(siteLatestDateStr, 'reportdata'));
		//var currentDate = new Date(periodStartDate.getFullYear(), periodStartDate.getMonth(), periodStartDate.getDate());			
		var noDateKey = 'noDate';
		var sumKey = 'sumKey';
		var totalKey = 'totalKey';
		if (siteData != null)
		{
			if (!permissionDeniedForPatientName)
			{
				data = getJSONData(siteData, 'missingPatientName');
				tableRow.appendChild(getTableCellElement(data, 'reportdata'));
			}
			else
			{
				data = '-';
				tableRow.appendChild(getTableCellElement(data, 'reportdata'));
			}
			if (sampleType == 'specimen')
			{
				if (!permissionDeniedForPad)
				{
					data = getJSONData(siteData, 'missingPadReference');
					tableRow.appendChild(getTableCellElement(data, 'reportdata'));
				}
				else
				{
					data = '-';
					tableRow.appendChild(getTableCellElement(data, 'reportdata'));
				}
				
				data = getJSONData(siteData, 'missingLaterality');
				tableRow.appendChild(getTableCellElement(data, 'reportdata'));
				data = getJSONData(siteData, 'missingSamplingDateTime');
				tableRow.appendChild(getTableCellElement(data, 'reportdata'));
				data = getJSONData(siteData, 'missingRnaLaterDateTime');
				tableRow.appendChild(getTableCellElement(data, 'reportdata'));
			}
			else if (sampleType == 'nospecimen')
			{
				if (!permissionDeniedForPad)
				{
					data = getJSONData(siteData, 'missingPadReference');
					tableRow.appendChild(getTableCellElement(data, 'reportdata'));
				}
				else
				{
					data = '-';
					tableRow.appendChild(getTableCellElement(data, 'reportdata'));
				}					
				data = getJSONData(siteData, 'missingLaterality');
				tableRow.appendChild(getTableCellElement(data, 'reportdata'));
				data = getJSONData(siteData, 'missingSamplingDateTime');
				tableRow.appendChild(getTableCellElement(data, 'reportdata'));
			}
			else if (sampleType == 'blood')
			{
				data = getJSONData(siteData, 'missingBloodSamplingDateTime');
				tableRow.appendChild(getTableCellElement(data, 'reportdata'));
				data = getJSONData(siteData, 'missingBloodFreezerDateTime');
				tableRow.appendChild(getTableCellElement(data, 'reportdata'));
			}
		}
		reportTable.appendChild(tableRow);
	}
}

function createLink(name, id, itemType, title)
{
	var link = document.createElement('span');
	link.className = 'link';
	link.title = title;
	link.innerHTML = name;
	Events.addEventHandler(link, 'click', Items.itemOnClick, {'item-id': id, 'item-type': itemType, 'no-edit': 1});
	return link;
}

function createTableCellElementChild(child, clazz, colspan, rowspan)
{
	var cellElement = document.createElement('td');
	cellElement.setAttribute('class', clazz);
	if (colspan != null) cellElement.setAttribute('colspan', colspan);
	if (rowspan != null) cellElement.setAttribute('rowspan', rowspan);
	cellElement.appendChild(child);
	
	return cellElement;
}

function getJSONDataWithPercent(jsonObject, key, sumKey, numDecimals)
{
	var dataNum = getJSONData(jsonObject, key);
	var dataSum = getJSONData(jsonObject, sumKey);
	var dataPct = '0';
	if (dataSum != null && dataSum != 0)
	{
		dataPct = 100*dataNum/dataSum;
		dataPct = dataPct.toFixed(numDecimals);
	}
	var data = dataNum + ' (' + dataPct + '%)';
	return data;
}

function getJSONData(jsonObject, key)
{
	var data = getJSONData(jsonObject, key, '');
	return data;
}

function getJSONData(jsonObject, key, defaultChoice)
{
	var data = defaultChoice;
	if (jsonObject != null)
	{
		if (jsonObject[key] != null)
		{
			data = jsonObject[key];
		}
	}
	/*
	else
	{
		data = 'jsonObject==null';
	}
	*/
	return data;
}

function addQuarterColumnHeaders(columnHeaderRow, startDate)
{
	var currentDate = startDate;
	for (var i=0;i<numCols;i++)
	{
		var quarter = Math.floor(currentDate.getMonth()/3)+1;
		var columnText = 'Q'+quarter;
		var quarterHeader = getTableCellElement(columnText, 'reportsubheader');
		columnHeaderRow.appendChild(quarterHeader);	
		currentDate.setMonth(currentDate.getMonth()+3);			
	}
}

function addWeekColumnHeaders(columnHeaderRow, startDate)
{
	var currentDate = startDate;
	var day = currentDate.getDay()-1;
	day = day>=0 ? day: day + 7;
	currentDate.setDate(currentDate.getDate()-day);
	for (var i=0;i<numCols;i++)
	{			
		var weekNum = getISOWeekNumber(currentDate);
		var columnText = weekNum;
		if (weekNum < 10) columnText = '0'+columnText;			
		columnHeaderRow.appendChild(getTableCellElement(columnText, 'reportsubheader'));
		currentDate.setDate(currentDate.getDate()+7);			
	}
}

function addMonthColumnHeaders(columnHeaderRow, startDate)
{		
	var currentDate = new Date(startDate.getFullYear(), startDate.getMonth());
	for (var i=0;i<numCols;i++)
	{							
		var monthHeader = getTableCellElement(month[currentDate.getMonth()], 'reportsubheader');
		columnHeaderRow.appendChild(monthHeader);				
		currentDate.setMonth(currentDate.getMonth() +1);
	}		
}

function addYearSubHeaders(startDate, endDate, subHeaderRowYear, vt)
{		
	var currentYear = startDate.getFullYear();	
	
	var columnCounter = 0;		
	do
	{
		var colspan;
		var headerText = currentYear;
		if (vt == "MONTH")
		{
			if (currentYear == startDate.getFullYear())
			{
				colspan =  11-startDate.getMonth()+1;
				if (endDate.getFullYear() == currentYear)
				{
					colspan = colspan - (11-endDate.getMonth());
				}
			}
			else if (currentYear == endDate.getFullYear()) 
				colspan = endDate.getMonth()+1;
			else
				colspan = 12;
		}
		else if (vt == "WEEK")
		{	
			if (startDate.getFullYear() == endDate.getFullYear())
			{
				colspan = numCols;
			}
			else if (currentYear == startDate.getFullYear())
			{
				var startWeek = getISOWeekNumber(startDate);
				var lastDay = new Date(startDate.getFullYear(), 11, 31);
				var endWeek = getISOWeekNumber(lastDay);
				if (endWeek == 1)
				{
					lastDay.setDate(lastDay.getDate()-7);
					endWeek = getISOWeekNumber(lastDay);
				}
				colspan = endWeek - startWeek +1;
			}
			else if (currentYear == endDate.getFullYear())
			{
				var endWeek = getISOWeekNumber(endDate);
				colspan = endWeek;
			}
			else
			{
				var dateInLastWeek = new Date(currentYear, 11, 31);
				var endWeek = getISOWeekNumber(dateInLastWeek);
				if (endWeek == 1)
				{
					dateInLastWeek.setDate(dateInLastWeek.getDate()-7);
					endWeek = getISOWeekNumber(dateInLastWeek);
				}
				colspan = endWeek;
			}								
		}
		else if (vt == "QUARTER")
		{
			if (currentYear == startDate.getFullYear())
			{
				if (startDate.getFullYear() == endDate.getFullYear())
				{
					colspan = Math.floor((endDate.getMonth()-startDate.getMonth())/3)+1;
				}
				else
				{
					colspan = Math.floor((11-startDate.getMonth())/3) +1;
				}
			}
			else if(currentYear == endDate.getFullYear())
			{
				colspan = Math.floor(endDate.getMonth()/3)+1;
			}
			else 
			{
				colspan = 4;
			}
		}
		else if (vt == "YEAR")
		{
			colspan = 1;				
		}
		columnCounter += colspan;						
		subHeaderRowYear.appendChild(getTableCellElement(headerText, 'reportsubheader', colspan));
	}while(!(++currentYear>endDate.getFullYear()));
}

function addDataRowsToTable(report, reportTable)
{
	var fdString = report.beginDate;
	var ldString = report.endDate;
	var psdString = report.periodBeginDate;
	var startDate = new Date();
	startDate.setYear(fdString.substr(0,4));
	startDate.setMonth(fdString.substr(4,2)-1);
	startDate.setDate(fdString.substr(6));
	var endDate = new Date();
	endDate.setYear(ldString.substr(0,4));
	endDate.setMonth(ldString.substr(4,2)-1);
	endDate.setDate(ldString.substr(6));
	var periodStartDate = new Date();
	periodStartDate.setYear(psdString.substr(0,4));
	periodStartDate.setMonth(psdString.substr(4,2)-1);
	periodStartDate.setDate(psdString.substr(6));
	var viewType = report.viewType;		
	var sites = report.sites;		
	var statistics = report.statistics;
	unknownCreation = statistics.noDate;
	unknownSite = statistics.unknownSite;
	for (var siteNo = 0; siteNo < sites.length; siteNo++)
	{
		var site = sites[siteNo];
		var siteName = site.name;		
		var year = site.startDate.substr(0,4);
		var month = site.startDate.substr(5,2);
		var date = site.startDate.substr(8,2);			
		var siteStartDate = new Date(year, month-1, date);
		
		var siteData = statistics[site.prefix];
		var siteLatestDate = siteData['latestDateKey'];
		var siteLatestDateStr = '????-??-??';
		if (siteLatestDate != null)
		{
			var siteLatestDateYear = siteLatestDate.substr(0,4);
			var siteLatestDateMonth = siteLatestDate.substr(4,2);
			var siteLatestDateDate = siteLatestDate.substr(6,2);
			siteLatestDateStr = siteLatestDateYear + '-' + siteLatestDateMonth + '-' + siteLatestDateDate;
		}
		var tableRow = document.createElement('tr');
		var tableCol = getTableCellElement(siteName, 'rowtitle');
		tableRow.appendChild(tableCol);
		tableRow.appendChild(getTableCellElement(year+'-'+(month)+'-'+date, 'reportdata'));
		tableRow.appendChild(getTableCellElement(siteLatestDateStr, 'reportdata'));
		var currentDate = new Date(periodStartDate.getFullYear(), periodStartDate.getMonth(), periodStartDate.getDate());			
		var columnCounter = 0;
		do
		{	
			var data = 0;
			var keyIndex;
			var yearIndex = currentDate.getFullYear();
			
			if (viewType == 'YEAR')
			{
				keyIndex = yearIndex;
				if (siteData != null)
				{
					if (siteData[keyIndex] != null) data = siteData[keyIndex];
				}
				// Initialize data columns before site start date to empty string
				if ( (currentDate.getFullYear() < siteStartDate.getFullYear()))
				{
					data = '';
				}
				currentDate.setFullYear(currentDate.getFullYear()+1);
			}
			else if (viewType == 'QUARTER')
			{
				var qIndex = Math.floor(currentDate.getMonth()/3) + 1;
				var startQuarter = Math.floor(siteStartDate.getMonth()/3)+1;
				keyIndex = yearIndex + '' + qIndex;
				if (siteData != null)
				{
					if (siteData[keyIndex] != null) data = siteData[keyIndex];						
				}					
				// Initialize data columns before site start date to empty string
				if ( (currentDate.getFullYear() < siteStartDate.getFullYear()) ||
				     (currentDate.getFullYear() == siteStartDate.getFullYear() && qIndex < startQuarter))
				{
					data = '';
				}
				currentDate.setMonth(currentDate.getMonth()+3);					
			}
			else if (viewType == 'MONTH')
			{
				var monthIndex = currentDate.getMonth()+1;
				var rowFill = monthIndex < 10 ? '0' : '';
				keyIndex = yearIndex + rowFill + monthIndex;
				if (siteData != null)
				{
					if (siteData[keyIndex] != null) data = siteData[keyIndex];
				}
				// Initialize data columns before site start date to empty string
				if ( (currentDate.getFullYear() < siteStartDate.getFullYear()) ||
				     (currentDate.getFullYear() == siteStartDate.getFullYear() && (monthIndex-1) < siteStartDate.getMonth()))
				{
					data = '';
				}
				currentDate.setMonth(currentDate.getMonth()+1);
			}
			else if (viewType == 'WEEK')
			{
				var weekIndex = getISOWeekNumber(currentDate);
				// Week number in year stored as yyyyww with leading 0 if needed
				if (weekIndex < 10)
				{
					keyIndex = yearIndex + '0' + weekIndex;
				}
				else
				{
					keyIndex = yearIndex + '' + weekIndex;
				}
				if (siteData != null)
				{
					if (siteData[keyIndex] != null) data = siteData[keyIndex];
				}
				// Initialize data columns before site start date to empty string
				//
				// Note: ISO week numbers are tricky in their short form (without being coupled to a year),
				// since days in different years may lie in the same week, and days at the start of
				// a year may have week number 52 or 53 of the previous year and days at the end of
				// a year may have week number 01 of the next year.
				// Example: Monday 2012-01-02 has week number 2012-01, Monday 2012-12-31 has week number 2013-01
				// If current date is before site start date - 6 days, it is in a previous week
				// If current date is within site start date +/- 6 days and not in the same week, check dates
				// (just checking week numbers in the last case leads to e.g. 2012-12-30 (w52) > 2012-12-31 (w01))
				//
				if (currentDate.getTime() < siteStartDate.getTime() - 6*24*3600*1000 ||
				    currentDate.getTime() < siteStartDate.getTime() + 6*24*3600*1000 &&
				       getISOWeekNumber(currentDate) != getISOWeekNumber(siteStartDate) &&
				       currentDate < siteStartDate)
				{
					data = '';
				}
				currentDate.setDate(currentDate.getDate()+7);
			}
			
			tableRow.appendChild(getTableCellElement(data, 'reportdata'));
			columnCounter++;				
		} while (columnCounter < numCols)
		// Add column with sample sum for site for the selected time period
		var siteSum = 0;
		if (siteData != null)
		{
			var sumSiteKey = 'sumSiteKey';
			if (siteData[sumSiteKey] != null)
			{
				siteSum = siteData[sumSiteKey];
			}
		}
		tableRow.appendChild(getTableCellElement(siteSum, 'rowsummary'));
		// Add column with total number of samples for site, regardless of creation date
		var siteTotal = 0;
		if (siteData != null)
		{
			var totalSiteKey = 'totalSiteKey';
			if (siteData[totalSiteKey] != null)
			{
				siteTotal = siteData[totalSiteKey];
			}
		}
		tableRow.appendChild(getTableCellElement(siteTotal, 'rowsummary'));
		reportTable.appendChild(tableRow);
	}
}

function createSortedPeriodArray(report, numberOfColumns)
{
	var psdString = report.periodBeginDate;
	var periodStartDate = new Date();
	periodStartDate.setYear(psdString.substr(0,4));
	periodStartDate.setMonth(psdString.substr(4,2)-1);
	periodStartDate.setDate(psdString.substr(6));
	var viewType = report.viewType;		
	var sortedPeriodArray = Array(numberOfColumns);
	var currentDate = new Date(periodStartDate.getFullYear(), periodStartDate.getMonth(), periodStartDate.getDate());			
	var columnCounter = 0;
	do
	{	
		var keyIndex;
		var yearIndex = currentDate.getFullYear();
			
		if (viewType == 'YEAR')
		{
			keyIndex = yearIndex;
			currentDate.setFullYear(currentDate.getFullYear()+1);
		}
		else if (viewType == 'QUARTER')
		{
			var qIndex = Math.floor(currentDate.getMonth()/3) + 1;
			keyIndex = yearIndex + '' + qIndex;
			currentDate.setMonth(currentDate.getMonth()+3);					
		}
		else if (viewType == 'MONTH')
		{
			var monthIndex = currentDate.getMonth()+1;
			var rowFill = monthIndex < 10 ? '0' : '';
			keyIndex = yearIndex + rowFill + monthIndex;
			currentDate.setMonth(currentDate.getMonth()+1);
		}
		else if (viewType == 'WEEK')
		{
			var weekIndex = getISOWeekNumber(currentDate);
			// Week number in year stored as yyyyww with leading 0 if needed
			if (weekIndex < 10)
			{
				keyIndex = yearIndex + '0' + weekIndex;
			}
			else
			{
				keyIndex = yearIndex + '' + weekIndex;
			}
			currentDate.setDate(currentDate.getDate()+7);
		}
		sortedPeriodArray[columnCounter] = keyIndex;
		columnCounter++;				
	} while (columnCounter < numberOfColumns)
	return sortedPeriodArray;
}

function getReportTable()
{
		var reportTable = document.createElement('table');
		reportTable.setAttribute('class','reporttable');
		reportTable.setAttribute('border','1');			
		return reportTable;
}

function getTableCellElement(text, clazz, colspan, rowspan)
{
	var cellElement = document.createElement('td');
	text = new String(text);		
	var textArray = text.split("\n");		
	if (textArray.length > 1)
	{	
		for (var i=0;i<textArray.length;i++)
		{				
			if (i>0)cellElement.appendChild(document.createElement('br'));
			cellElement.appendChild(document.createTextNode(textArray[i]));
		}			
	}
	else
	{
		cellElement.appendChild(document.createTextNode(text));
	}
	cellElement.setAttribute('class', clazz);
	if (colspan != null) cellElement.setAttribute('colspan', colspan);
	if (rowspan != null) cellElement.setAttribute('rowspan', rowspan);
	
	return cellElement;
}

function getListElement(itemText)
{
	var listElement = document.createElement('li');
	var textNode = document.createTextNode(itemText);
	listElement.appendChild(textNode);
	return listElement;
}

/**
 *	addHyphensToDateStr()
 *
 *	Adds hyphens to date string in yyyymmdd format to
 *	get yyyy-mm-dd format. If input string already contains
 *	hyphen(s), the input string is returned unchanged.
 *	If input string is null or empty, '????-??-??' is returned.
 *
 *	@param dateStr String Input date string in yyyy-mm-dd or yyyymmdd format.
 *	@return String Date string in yyyy-mm-dd format.
 */
function addHyphensToDateString(dateStr)
{
	var dateWithHyphensStr = '????-??-??';
	if (dateStr != null && dateStr != '')
	{
		// Check if input string already contains hyphen
		if (dateStr.indexOf("-") >= 0)
		{
			// Date already has hyphen(s)
			dateWithHyphensStr = dateStr;
		}
		else
		{
			// Date in yyyymmdd format
			var yearStr = dateStr.substr(0,4);
			var monthStr = dateStr.substr(4,2);
			var dayStr = dateStr.substr(6,2);			
			dateWithHyphensStr = yearStr + '-' + monthStr + '-' + dayStr;
		}
	}
	return dateWithHyphensStr;
}

/**
 *	dateStrToDate()
 *
 *	Takes an input date string in yyyy-mm-dd or yyyymmdd format
 *	and returns a date corresponding to the date string.
 *	If input string is null or empty, null is returned.
 *
 *	@param dateStr String Input date string in yyyy-mm-dd or yyyymmdd format.
 *	@return Date Date corresponding to input date string.
 */
function dateStrToDate(dateStr)
{
	var date = null;
	if (dateStr != null && dateStr != '')
	{
		// Check if input string already contains hyphen
		if (dateStr.indexOf("-") >= 0)
		{
			// Date in yyyy-mm-dd format
			var yearStr = dateStr.substr(0,4);
			var monthStr = dateStr.substr(5,2);
			var dayStr = dateStr.substr(8,2);			
			var date = new Date(parseInt(yearStr, 10), parseInt(monthStr, 10)-1, parseInt(dayStr, 10));
		}
		else
		{
			// Date in yyyymmdd format
			var yearStr = dateStr.substr(0,4);
			var monthStr = dateStr.substr(4,2);
			var dayStr = dateStr.substr(6,2);			
			var date = new Date(parseInt(yearStr, 10), parseInt(monthStr, 10)-1, parseInt(dayStr, 10));
		}
	}
	return date;
}

/*
 *	Get the ISO week number for a given date
 * 
 *	Based on code at http://stackoverflow.com/questions/6117814/get-week-of-year-in-javascript-like-in-php
 *
 *	@param date String Input date to get ISO week number for.
 *	@return int ISO week number for input date.
 */
function getISOWeekNumber(date)
{
	tmpDate = new Date(date);
	tmpDate.setHours(0,0,0);
	// Set to nearest Thursday: current date + 4 - current day number
	// Make Sunday day number 7
	tmpDate.setDate(tmpDate.getDate() + 4 - (tmpDate.getDay() || 7));
	// Get first day of year
	var yearStart = new Date(tmpDate.getFullYear(), 0, 1);
	// Calculate full weeks to nearast Thursday (86400000 = 24*60*60*1000 number of ms in a day)
	var weekNo = Math.ceil(( ( (tmpDate - yearStart) / 86400000) + 1)/7);
	return weekNo;
}


function getBloodSampleFilterDisplayText(bloodSampleFilter)
{
	var bloodSampleFilterDisplayText = bloodSampleFilter;
	if (bloodSampleFilter == 'followup')
	{
		bloodSampleFilterDisplayText = 'Follow-up';
	}
	else if (bloodSampleFilter == 'notfollowup')
	{
		bloodSampleFilterDisplayText = 'Not follow-up';
	}
	else if (bloodSampleFilter == '')
	{
		bloodSampleFilterDisplayText = 'unknown';
	}
	return bloodSampleFilterDisplayText;
}
