<%@ page
	pageEncoding="UTF-8"
	session="false"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.clients.web.Base"	
	import="net.sf.basedb.clients.web.util.HTML"	
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(request, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final String home = ExtensionsControl.getHomeUrl("net.sf.basedb.reggie");
DbControl dc = null;
try
{
	dc = sc.newDbControl();
	final User user = User.getById(dc, sc.getLoggedInUserId());
%>
<base:page type="default" >
<base:head 
	scripts="~../reggie-2.js,~rnaqc_plate_import.js" 
	styles="path.css,~../css/reggie-2.css"
/>
<base:body>

	<p:path><p:pathelement 
		title="Reggie" href="<%="../index.jsp?ID="+ID%>" 
		/><p:pathelement title="RNA quality control - Import Caliper results" 
		/></p:path>

	<div class="content">

	<form name="reggie" id="wizard" class="wizard">
		<input type="hidden" name="csv.id" value="">
		<input type="hidden" name="gxd.std.id" value="">
		<input type="hidden" name="gxd.hi.id" value="">
		<input type="hidden" name="pdf.id" value="">
	
	<!-- 1. Select files -->
	<div class="step" id="step-1">
		<div class="step-no">1</div>
		<div class="step-title">Select data files</div>
		<div class="step-content">

			<table class="step-form">
			<tr class="align-top">
				<td class="prompt">Well table CSV</td>
				<td class="input">
					<table style="width: 100%;">
					<tr>
					<td>
						<input class="text required" type="text" name="csv" id="csv" 
							data-subtype="CALIPER_WELL_TABLE" data-name-filter="%.csv"
							data-directory="/home/SCANB/RNAQC"
						>
					</td>
					<td style="padding-left: 4px; width: 7em;">
						<base:button 
							title="Browse&hellip;"
							id="csv.btn"
						/>
					</td>
					</tr>
					</table>
				</td>
				<td class="status" id="csv.status"></td>
				<td class="help">
					<span id="csv.message" class="message"></span>
					Select the <b>Well Table CSV file</b> that contains the exported analysis result from the
					Caliper software.
				</td>
			</tr>
			
			<tr class="align-top">
				<td class="prompt">GXD standard</td>
				<td class="input">
					<table style="width: 100%;">
					<tr>
					<td>
						<input class="text" type="text" name="gxdstd" id="gxdstd" 
							data-subtype="CALIPER_RAW_DATA" data-name-filter="%.gxd"
							data-directory="/home/SCANB/RNAQC"
						>
					</td>
					<td style="padding-left: 4px; width: 7em;">
						<base:button 
							title="Browse&hellip;"
							id="gxdstd.btn"
						/>
					</td>
					</tr>
					</table>		
				</td>
				<td class="status" id="gxdstd.status"></td>
				<td class="help">
					<span id="gxdstd.message" class="message"></span>
					Select the <b>Standard GXD file</b> that contains the raw data.
				</td>
			</tr>
			<tr class="align-top">
				<td class="prompt">GXD high sense</td>
				<td class="input">
					<table style="width: 100%;">
					<tr>
					<td>
						<input class="text" type="text" name="gxdhi" id="gxdhi" 
							data-subtype="CALIPER_RAW_DATA" data-name-filter="%.gxd"
							data-directory="/home/SCANB/RNAQC"
						>
					</td>
					<td style="padding-left: 4px; width: 7em;">
						<base:button 
							title="Browse&hellip;"
							id="gxdhi.btn"
						/>
					</td>
					</tr>
					</table>		
				</td>
				<td class="status" id="gxdhi.status"></td>
				<td class="help">
					<span id="gxdhi.message" class="message"></span>
					Select the <b>High sense GXD file</b> that contains the raw data.
				</td>
			</tr>
			<tr valign="top">
				<td class="prompt">PDF file</td>
				<td class="input">
					<table style="width: 100%;">
					<tr>
					<td>
						<input class="text" type="text" name="pdf" id="pdf" 
							data-subtype="CALIPER_PDF" data-name-filter="%.pdf"
							data-directory="/home/SCANB/RNAQC"
						>
					</td>
					<td style="padding-left: 4px; width: 7em;">
						<base:button 
							title="Browse&hellip;"
							id="pdf.btn"
						/>
					</td>
					</tr>
					</table>		
				</td>
				<td class="status" id="pdf.status"></td>
				<td class="help">
					<span id="pdf.message" class="message"></span>
					Select the PDF file that contains a printout with diagrams and other
					useful documentation.
				</td>
			</tr>
			<tr id="bioplateSection">
				<td class="prompt">Bioplate</td>
				<td class="input"><span id="bioplate.name"><i>no file loaded</i></span></td>
				<td class="status" id="bioplate.status"></td>
				<td class="help">
					<span id="bioplate.message" class="message"></span>
				</td>
			</tr>
			<tr>
				<td class="prompt">QC Run Date</td>
				<td class="input">
					<input type="text" name="qcRunDate" id="qcRunDate"
						class="auto-init" data-auto-init="focus-on-enter" data-next-focus="qcOperator"
						style="width: 8em;" maxlength="10">
						<base:icon 
							id="qcRunDateCalendar"
							subclass="auto-init"
							data-auto-init="calendar"
							data-textarea-id="qcRunDate"
							data-date-format="yyyyMMdd"
							data-title="QC run date"
							image="calendar.png" 
							tooltip="Select a date from a calendar" 
							tabindex="-1"
						/>
				</td>
				<td class="status" id="qcRunDate.status"></td>
				<td class="help">
					<span id="qcRunDate.message" class="message"></span>
					(YYYYMMDD or MMDD)
				</td>
			</tr>
			<tr>
				<td class="prompt">QC Operator</td>
				<td class="input">
					<input type="text" name="qcOperator" id="qcOperator" 
						value="<%=HTML.encodeTags(user.getName()) %>" maxlength="255">
				</td>
				<td class="status" id="qcOperator.status"></td>
				<td class="help">
					<span id="qcOperator.message" class="message"></span>
				</td>
			</tr>
			</table>
		</div>
	</div>
	
	<div id="wizard-status"></div>
	
	<table class="navigation" id="navigation">
	<tr>
		<td><base:button id="gocancel" title="Cancel" /></td>
		<td><base:button id="gonext" title="Next" image="<%=home+"/images/gonext.png"%>" /></td>
		<td><base:button id="goregister" title="Register" image="<%=home+"/images/import.png"%>"  /></td>
		<td><base:button id="gorestart" title="Restart" image="<%=home+"/images/goback.png"%>" /></td>
		<td id="gonext-message" class="message"></td>
	</tr>
	</table>
	
	</form>
	</div>
	
</base:body>
</base:page>
<%
}
finally
{
	if (dc != null) dc.close();
}
%>